Package: dandelionR
Title: Single-cell Immune Repertoire Trajectory Analysis in R
Version: 1.3.0
Authors@R: 
    c(person(given="Jiawei", family="Yu", email = "jiawei.yu@uq.edu.au", role = c("aut"), comment = c(ORCID = "0009-0005-9170-7881")),
      person(given="Nicholas", family="Borcherding", email = "borcherding@wustl.edu", role = c("aut"), comment = c(ORCID = "0000-0003-1427-6342")),
      person(given="Kelvin", family="Tuong", email = "z.tuong@uq.edu.au", role = c("aut", "cre"), comment = c(ORCID = "0000-0002-6735-6808")))
Description: dandelionR is an R package for performing single-cell immune repertoire trajectory analysis, based on the original python implementation. It provides the necessary functions to interface with scRepertoire and a custom implementation of an absorbing Markov chain for pseudotime inference, inspired by the Palantir Python package.
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
biocViews: Software, ImmunoOncology, SingleCell
Collate: 'check.R' 'constructMarkovChain.R' 'dandelionR.R' 'data.R'
        'determMultiscaleSpace.R' 'terminalStateFromMarkovChain.R'
        'differentiationProbabilities.R' 'filterCells.R' 'getPbs.R'
        'projectProbability.R' 'maxMinSampling.R' 'minMaxScale.R'
        'markovProbability.R' 'miloUmap.R' 'projectPseudotimeToCell.R'
        'setupVdjPseudobulk.R' 'splitCTgene.R' 'vdjPseudobulk.R'
Imports: BiocGenerics, bluster, destiny, igraph, MASS, Matrix, methods,
        miloR, purrr, rlang, S4Vectors, SingleCellExperiment, spam,
        stats, SummarizedExperiment, uwot, RANN
Suggests: BiocStyle, fields, knitr, rmarkdown, RColorBrewer, scater,
        scRepertoire, DelayedMatrixStats, slingshot, testthat
VignetteBuilder: knitr
URL: https://www.github.com/tuonglab/dandelionR/
BugReports: https://www.github.com/tuonglab/dandelionR/issues
Depends: R (>= 4.4.0)
git_url: https://git.bioconductor.org/packages/dandelionR
git_branch: devel
git_last_commit: 29dd237
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-06
NeedsCompilation: no
Packaged: 2025-11-06 22:07:57 UTC; biocbuild
Author: Jiawei Yu [aut] (ORCID: <https://orcid.org/0009-0005-9170-7881>),
  Nicholas Borcherding [aut] (ORCID:
    <https://orcid.org/0000-0003-1427-6342>),
  Kelvin Tuong [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6735-6808>)
Maintainer: Kelvin Tuong <z.tuong@uq.edu.au>

[![codecov](https://codecov.io/gh/tuonglab/dandelionR/graph/badge.svg?token=dd1bBTW48K)](https://codecov.io/gh/tuonglab/dandelionR)
[![R-CMD-check](https://github.com/tuonglab/dandelionR/actions/workflows/R-CMD-check.yml/badge.svg)](https://github.com/tuonglab/dandelionR/actions/workflows/R-CMD-check.yml)
[![vignette](https://github.com/tuonglab/dandelionR/actions/workflows/vignette.yml/badge.svg)](https://github.com/tuonglab/dandelionR/actions/workflows/vignette.yml)

# dandelionR

Welcome to `dandelionR`!

`dandelionR` is an R package for performing single-cell immune repertoire trajectory analysis, based on the original python implementation in [`dandelion`](https://www.github.com/zktuong/dandelion).

It provides all the necessary tools to interface with [`scRepertoire`](https://github.com/ncborcherding/scRepertoire) and a custom implementation of absorbing markov chain for pseudotime inference, inspired based on the [palantir](https://github.com/dpeerlab/Palantir) python package.

## Installation from Bioconductor

You can install `dandelionR` from Bioconductor with:

```R
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# If installing from Bioc devel, do this first:
# BiocManager::install(version="devel")

BiocManager::install("dandelionR")
```

## Installation from GitHub

You can install `dandelionR` from GitHub with:

```R
if (!requireNamespace("devtools", quietly = TRUE))
    install.packages("devtools")
devtools::install_github('tuonglab/dandelionR', dependencies = TRUE)
```

## Quick Start

```R
library(dandelionR)
```

This is a work in progress, so please feel free to open an issue if you encounter any problems or have any suggestions for improvement.

## Citation

If you use `dandelionR` in your work, you can cite our manuscript published in the [Computational and Structural Biotechnology Journal](https://authors.elsevier.com/sd/article/S2001-0370(25)00263-6):

```
Yu, J., Xu, X., Borcherding, N., Tuong, Z.K. dandelionR: Single-cell immune repertoire trajectory analysis in R. Comput. Struct. Biotechnol. J. (2025). doi:10.1016/j.csbj.2025.06.047.
```

Please also cite the original `dandelion` paper:

```
Suo, C. et al. Dandelion uses the single-cell adaptive immune receptor repertoire to explore lymphocyte developmental origins. Nat. Biotechnol. 42, 40-51 (2024). doi:10.1038/s41587-023-01734-7
```

#' Project Pseudotime and Branch Probabilities to Single Cells
#'
#' This function projects pseudotime and branch probabilities from pseudobulk
#' data to single-cell resolution (`milo`). The results are stored in the
#' `colData` of the `milo` object.
#'
#' @param milo A `SingleCellExperiment` or `Milo` object. Represents single-cell
#' data where pseudotime and branch probabilities will be projected.
#' @param pb_milo A pseudobulk `Milo` object. Contains aggregated branch
#' probabilities and pseudotime information to be transferred to single cells.
#' @param value_key Character. The column name in `colData` of `pb_milo`
#' that contains the value that is needed to be projected back. Default is `NULL`.
#' @param suffix Character. A suffix to be added to the new column names in
#' `colData`. Default is an empty string (`''`).
#' @param verbose Boolean, whether to print messages/warnings.
#'
#' @examples
#' data(sce_vdj)
#' # downsample to first 2000 cells
#' sce_vdj <- sce_vdj[, 1:2000]
#' sce_vdj <- setupVdjPseudobulk(sce_vdj,
#'     already.productive = FALSE,
#'     allowed_chain_status = c("Single pair", "Extra pair")
#' )
#' # Build Milo Object
#' set.seed(100)
#' milo_object <- miloR::Milo(sce_vdj)
#' milo_object <- miloR::buildGraph(milo_object,
#'     k = 50, d = 20,
#'     reduced.dim = "X_scvi"
#' )
#' milo_object <- miloR::makeNhoods(milo_object,
#'     reduced_dims = "X_scvi",
#'     d = 20
#' )
#'
#' # Construct Pseudobulked VDJ Feature Space
#' pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
#' pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")
#'
#' # Define root and branch tips
#' pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
#' branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
#' names(branch.tips) <- c("CD8+T", "CD4+T")
#' root <- which.min(pca[, 1])
#'
#' # Construct Diffusion Map
#' dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
#' dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
#'
#' # Markov Chain Construction
#' pb.milo <- markovProbability(
#'     milo = pb.milo,
#'     diffusionmap = dm,
#'     diffusiontime = dif.pse[[paste0("DPT", root)]],
#'     terminal_state = branch.tips,
#'     root_cell = root,
#'     pseudotime_key = "pseudotime"
#' )
#' # Project Pseudobulk Data
#' projected_milo <- projectPseudotimeToCell(
#'     milo_object,
#'     pb.milo,
#'     value_key = c("pseudotime", "CD8+T", "CD4+T")
#' )
#'
#' @return subset of milo or SingleCellExperiment object where cell that do not
#' belong to any neighbourhood are removed and projected pseudotime information
#' stored colData
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @importFrom S4Vectors metadata
#' @export
projectPseudotimeToCell <- function(
    milo, pb_milo, value_key = NULL, suffix = "", verbose = TRUE) {
    if (is.null(value_key)) {
        abort("Please specify the column name(s) of the value(s) to be projected back.")
    } else if (!all(value_key %in% colnames(colData(pb_milo)))) {
        missing_value <- value_key[!(value_key %in% colnames(colData(pb_milo)))]
        abort(sprintf(
            "value %s do(es) not exist in pseudobulk `Milo` object.",
            paste(missing_value, collapse = ", ")
        ))
    }
    nhood <- miloR::nhoods(pb_milo) # peudobulk x cells
    # leave out cells that do not blongs to any neighbourhood
    nhoodsum <- apply(miloR::nhoods(pb_milo), 2, sum)
    cdata <- milo[, nhoodsum > 0]
    if (verbose) {
        message(sprintf(
            c(
                "%d number of cells removed due to not belonging to any",
                " neighbourhood"
            ),
            sum(nhoodsum == 0)
        ))
    }
    # for each cell pesudotime_mean is the average of the pseudobulks the cell
    # is in, weighted by 1/ neighbourhood size
    nhoods_cdata <- nhood[, nhoodsum > 0]
    nhoods_cdata_norm <- nhoods_cdata / apply(nhoods_cdata, 1, sum)
    col_list <- value_key
    new_col <- mapply(
        function(x, value_name) {
            project_single_value(x, nhoods_cdata_norm, value_name, verbose)
        },
        colData(pb_milo)[, col_list]@listData,
        col_list,
        SIMPLIFY = FALSE
    )
    colData(cdata) <- cbind(colData(cdata), new_col)
    return(cdata)
}

#' Function to project pseudobulk-level values to single-cell level
#'
#' @param x Numeric vector, pseudobulk-level value to be projected.
#' @param y Matrix (pseudobulk x cell), used to project x back to cell level.
#' @param value_name Character, name of the value being projected.
#' @param verbose Boolean, whether to print messages/warnings.
#' @return Numeric vector of projected values at cell level.
project_single_value <- function(x, y, value_name, verbose = TRUE) {
    na_idx <- is.na(x)
    if (any(na_idx)) { # nocov
        if (all(na_idx)) {
            abort(paste("All values for", value_name, "are NA."))
        }
        # exclude pseudobulk with NA value
        x <- x[!na_idx]
        modi_y <- y[!na_idx, , drop = FALSE]
        col_sums <- Matrix::colSums(modi_y)
        zero_cols <- sum(col_sums == 0)
        if (verbose) {
            message(sprintf(
                "%d cells do not have projected values for %s because their neighbour(s) value is NA",
                zero_cols, value_name
            ))
        }
    } else {
        modi_y <- y
    }
    col_sums <- Matrix::colSums(modi_y)
    col_sums[col_sums == 0] <- NA
    na_cols <- is.na(col_sums)
    inv_col_sums <- 1 / col_sums
    weights <- modi_y %*% Matrix::Diagonal(x = inv_col_sums)
    # return projection result
    result <- as.vector(x %*% weights)
    result[na_cols] <- NA
    result
}

library(miloR)
library(SingleCellExperiment)

# Mock data for testing
set.seed(100)
data(sce_vdj)
# downsample to first 2000 cells to speed up the testing.
sce_vdj <- sce_vdj[, 1:2000]
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object, reduced_dims = "X_scvi", d = 20)
# Construct Pseudobulked VDJ Feature Space
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")
# Define root and branch tips
pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
names(branch.tips) <- c("CD8+T", "CD4+T")
root <- which.max(pca[, 1])
# Construct Diffusion Map
dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    terminal_state = branch.tips,
    diffusiontime = dif.pse[[paste0("DPT", root)]],
    root_cell = root,
    pseudotime_key = "pseudotime"
)
# Test for projectPseudotimeToCell
test_that("projectPseudotimeToCell works correctly", {
    result <- projectPseudotimeToCell(milo_object, pb.milo, value_key = c("pseudotime", "CD4+T", "CD8+T"))

    expect_true(is(result, "SingleCellExperiment"))
    expect_true("pseudotime" %in% colnames(colData(result)))
    expect_true(all(c("CD8+T", "CD4+T") %in% colnames(colData(result))))
})

# Additional tests for edge cases
test_that("projectPseudotimeToCell cannot work without pseudotime column", {
    # Test with wrong column
    expect_error(
        projectPseudotimeToCell(milo_object, pb.milo, value_key = c("wrong_pseudotime", "CD4+T", "CD8+T"), ),
        "value .* do\\(es\\) not exist in pseudobulk `Milo` object."
    )
    # Test with missing value_key
    value_keys <- NULL
    expect_error(
        projectPseudotimeToCell(milo_object, pb.milo, value_key = value_keys),
        "Please specify the column name\\(s\\) of the value\\(s\\) to be projected back\\."
    )
})

#' .getPbs
#'
#' Helper function to ensure we have cells by pseudobulks matrix which we can
#' use for pseudobulking.
#' @param pbs pbs parameter provided by vdjPseudobulk(),  cells by pseudobulks
#' matrix or NULL
#' @param col_to_bulk col_to_bulk parameter provided by vdjPseudobulk(),
#' column's name of colData from milo
#' @param milo SingleCellExperiment object
#' @param verbose logical, whether to print messages
#' @importFrom rlang abort
#' @importFrom stats model.matrix
#' @importFrom Matrix Matrix
#' @keywords internal
#' @return a cell x pseudobulk matrix
.getPbs <- function(pbs, col_to_bulk, milo, verbose = TRUE) {
    # some way to pseudobulk
    if (is.null(pbs) && is.null(col_to_bulk)) {
        abort("You must specify 'pbs' or 'col_to_bulk'.")
    }
    # but just one
    if (!is.null(pbs) && !is.null(col_to_bulk)) {
        abort("You must specify 'pbs' or 'col_to_bulk', not both.")
    }
    if (!is.null(pbs)) {
        return(pbs)
    }
    if (!is.null(col_to_bulk)) {
        msg <- paste0(col_to_bulk, collapse = ", ")
        if (verbose) {
            message(sprintf("Generating pseudobulks according to %s ...", msg),
                appendLF = FALSE
            )
        }
        tobulk <- lapply(col_to_bulk, function(x) {
            colData(milo)[[x]]
        })
        names(tobulk) <- col_to_bulk
        tobulk <- as.data.frame(tobulk)
        tobulk <- as.data.frame(apply(tobulk, 1, paste,
            collapse = ",",
            simplify = FALSE
        ))
        tobulk <- model.matrix(~ t(tobulk) - 1)
        colnames(tobulk) <- gsub("t\\(tobulk\\)", "", colnames(tobulk))
        tobulk <- Matrix(tobulk, sparse = TRUE)
        if (verbose) {
            message("Complete")
            message(sprintf("The number of pseudobulks is %d", dim(tobulk)[2]))
        }
        return(tobulk)
    }
}

#' .getPbsCol
#'
#' Helper function to create the new pseudobulk object's coldata.
#' @param pbs dgeMatrix, cell x pseudobulk binary matrix
#' @param col_to_take character vector, names of colData of milo that need to
#' be processed
#' @param milo Milo or SingleCellExperiment object
#' @importFrom Matrix t
#' @importFrom S4Vectors DataFrame
#' @importFrom stats model.matrix contrasts
#' @keywords internal
#' @return pbs_col, a DataFrame which will be passed to the new
#' SingleCellExperiment object as colData of vdj x pseudobulk assays
.getPbsCol <- function(pbs, col_to_take, milo) {
    # prepare per-pseudobulk calls of specified metadata columns
    if (!is.null(col_to_take)) {
        pbs.col <- DataFrame()
        pbs.col <- Reduce(function(pbs.col, anno_col) {
            pbs.col <- .getPbsPerCol(pbs.col, anno_col, milo, pbs)
            return(pbs.col)
        }, col_to_take, pbs.col)
    }
    # report the number of cells for each pseudobulk ensure pbs is an array so
    # that it sums into a vector that can go in easily
    pbs.col["cell_count"] <- apply(pbs, 2, sum)
    return(pbs.col)
}



#' .getPbsPerCol
#'
#' function used in Reduce to get the PbsCol
#' @param pbs.col DataFrame object used to store the result of each iteration
#' @param anno_col colname where to generate the metadata from
#' @param milo milo or SingleCellExperiment objects provided by user
#' @param pbs dgeMatrix, cell x pseudobulk binary matrix
#' @importFrom Matrix t
#' @importFrom S4Vectors DataFrame
#' @importFrom stats model.matrix contrasts
#' @keywords internal
#' @return DataFrame object, serve as part of metadata of the new milo object
.getPbsPerCol <- function(pbs.col, anno_col, milo, pbs) {
    fa <- as.factor(colData(milo)[[anno_col]])
    fa <- data.frame(fa)
    anno.dummies <- model.matrix(~ . - 1,
        data = fa,
        contrasts.arg = lapply(fa,
            contrasts,
            contrasts = FALSE
        )
    )
    anno.count <- t(pbs) %*% anno.dummies
    # t(cell x  pseudo)   %*% (cell x element) = pseudo x element
    anno.sum <- apply(anno.count, 1, sum)
    anno.frac <- anno.count / anno.sum
    anno.frac <- as.matrix(anno.frac)
    anno.frac <- DataFrame(anno.frac)
    colnames(anno.frac) <- colnames(anno.dummies)
    pbs.col[anno_col] <- colnames(anno.frac)[apply(anno.frac, 1, which.max)]
    pbs.col[paste0(anno_col, "_fraction")] <- apply(anno.frac, 1, max)
    return(pbs.col)
}

library(SingleCellExperiment)
library(Matrix)
library(rlang)

# Mock data for testing
set.seed(100)
data <- matrix(rnorm(100), ncol = 10)
col_data <- data.frame(
    sample_type = rep(c("A", "B"), each = 5),
    condition = rep(c("control", "treated"), times = 5)
)
sce <- SingleCellExperiment(assays = list(counts = data), colData = col_data)

# Test for .getPbs
test_that(".getPbs works correctly with pbs provided", {
    pbs <- Matrix::Matrix(matrix(1, nrow = 10, ncol = 2), sparse = TRUE)
    result <- .getPbs(pbs, NULL, sce)

    expect_true(is(result, "Matrix"))
    expect_equal(dim(result), c(10, 2))
})

test_that(".getPbs works correctly with col_to_bulk provided", {
    result <- .getPbs(NULL, c("sample_type", "condition"), sce)

    expect_true(is(result, "Matrix"))
    expect_equal(dim(result), c(10, 4))
    expect_equal(colnames(result), c(
        "A,control", "A,treated",
        "B,control", "B,treated"
    ))
})

test_that(".getPbs throws error when both pbs and col_to_bulk are NULL", {
    expect_error(
        .getPbs(NULL, NULL, sce),
        "You must specify 'pbs' or 'col_to_bulk'."
    )
})

test_that(".getPbs throws error when both pbs and col_to_bulk are provided", {
    pbs <- Matrix::Matrix(matrix(1, nrow = 10, ncol = 2), sparse = TRUE)
    expect_error(
        .getPbs(pbs, c("sample_type", "condition"), sce),
        "You must specify 'pbs' or 'col_to_bulk', not both."
    )
})

#' .constructMarkovChain
#'
#' Markov chain construction
#' @param wp_data Multi scale data of the waypoints
#' @param knn. Number of nearest neighbors for graph construction
#' @param pseudotime pseudotime ordering of cells
#' @param waypoints integer vector, index of selected waypoint used to
#' @param vb whether to print messages
#' @param use_RANN parameter to make user choose
#' whether to use RANN to construct Markov chain,
#' or keep using bluster
#'
#' @keywords internal
#' @importFrom bluster makeKNNGraph
#' @importFrom igraph ends E<- E as_adjacency_matrix
#' @importFrom Matrix sparseMatrix summary
#' @importFrom purrr pmap
#' @importFrom stats dist
#' @return transition matrix of the markov chain
.constructMarkovChain <- function(wp_data, knn.,
                                  pseudotime, waypoints, vb, use_RANN) {
    if (vb) message("Markov chain construction...")
    pseudotime <- pseudotime[waypoints]
    KNNind <- if (use_RANN) {
        .RANNinx(wp_data, knn.)
    } else {
        .KNNind(wp_data, knn.)
    }
    KNN <- KNNind$KNN
    ind <- KNNind$ind
    ## select Standard deviation allowing for 'back' edges
    adaptive.k <- min(c(floor(knn. / 3) - 1, 30))
    dist_ <- lapply(ind, function(y) KNN@x[y])
    dist_sort <- lapply(dist_, sort, decreasing = TRUE)
    adaptive.std <- vapply(dist_sort, "[", adaptive.k, FUN.VALUE = double(1))
    # Directed graph construction pseudotime position of all the
    # neighbors
    traj_nbrs <- lapply(ind, function(x) pseudotime[x])
    ## Remove edges that move backwards in pseudotime except for
    ## edges that are within the computed standard deviation
    rem_edges <- pmap(list(
        .x = traj_nbrs, .y = (pseudotime - adaptive.std), .z = ind
    ), function(.x, .y, .z) {
        .z[.x < .y]
    })
    KNN <- Reduce(function(Knn, i) {
        return(.removeEdge(Knn, i, rem_edges = rem_edges))
    }, seq_len(length(waypoints)), init = KNN)
    # determine the indices and update adjacency matrix
    # cell_mapping <- seq_len(length(waypoints))
    # seems cell_mapping is not used, if there is an error them edit back
    ids <- summary(KNN)
    # anisotropic Diffusion Kernel
    aff <- exp(-(ids$x^2) / (adaptive.std[ids$i]^2) * 0.5 -
        (ids$x^2) / (adaptive.std[ids$j]^2) * 0.5)
    W <- sparseMatrix(
        i = ids$i, j = ids$j, x = aff,
        dims = dim(KNN), giveCsparse = TRUE
    )
    # Transition matrix
    D <- apply(W, 1, sum)
    ids <- summary(W)
    T_ <- sparseMatrix(
        i = ids$i, j = ids$j, x = ids$x / D[ids$i],
        dims = dim(KNN), giveCsparse = TRUE
    )
    return(T_)
}

#' Calculate the weighted adjacency matrix of knn graph and its index
#' @param wp_data Multi scale data of the waypoints
#' @param knn. Number of nearest neighbors for graph construction
#' @keywords internal
#' @importFrom bluster makeKNNGraph
#' @importFrom igraph ends E<- E as_adjacency_matrix
#' @importFrom stats dist
#' @return a list containing the weight adjacent matrix and index
.KNNind <- function(wp_data, knn.) {
    nbrs <- makeKNNGraph(wp_data, k = knn.)
    ## calculate distance of each edge
    distance_m <- as.matrix(dist(wp_data))
    edge_indices <- ends(nbrs, E(nbrs))
    weights <- vapply(seq_len(nrow(edge_indices)), function(i) {
        ### Get the nodes connected by each edge
        node1 <- as.numeric(edge_indices[i, 1])
        node2 <- as.numeric(edge_indices[i, 2])
        ### Use the distance matrix to get the distance between the
        ### two nodes
        distance_m[node1, node2]
    }, numeric(1))
    E(nbrs)$weight <- weights
    ## generate weighted adjacent matrix of this knn graph
    KNN <- as_adjacency_matrix(nbrs, attr = "weight")
    ## generate the index of each neighbor
    knn_summary <- summary(KNN)
    ind <- split(knn_summary$j, knn_summary$i)
    return(list(KNN = KNN, ind = ind))
}

#' function used in Reduce to remove KNN's backward edges except for
#'  edges that are within the computed standard deviation
#'
#' @param Knn weight KNN adjacent matrix
#' @param i the iteration number
#' @param rem_edges the edges that need to be removes
#' @keywords internal
#' @return an updated matrix after one round of iteration
.removeEdge <- function(Knn, i, rem_edges) {
    if (length(Knn[i, rem_edges[[i]]])) {
        Knn[i, rem_edges[[i]]] <- 0
    }
    return(Knn)
}

#' Calculate the weight adjacent matricks of knn graph and its index using RANN
#' @param wp_data Multi scale data of the waypoints
#' @param knn. Number of nearest neighbors for graph construction
#' @keywords internal
#' @importFrom RANN nn2
#' @importFrom Matrix sparseMatrix
#' @importFrom stats dist
#' @return a list containing the weight adjacent matrix and index
.RANNinx <- function(wp_data, knn.) {
    RAKNN <- nn2(wp_data, k = knn.)
    row_indices <- rep(seq_len(nrow(RAKNN[["nn.dists"]])),
        times = ncol(RAKNN[["nn.dists"]])
    )
    col_indices <- as.vector(RAKNN[["nn.idx"]])
    x_values <- as.vector(RAKNN[["nn.dists"]])
    KNN <- sparseMatrix(
        i = row_indices,
        j = col_indices,
        x = x_values
    )
    ## generate the index of each neighbor
    ind <- split(
        as.vector(RAKNN[["nn.idx"]]),
        rep(1:nrow(RAKNN[["nn.idx"]]),
            times = ncol(RAKNN[["nn.idx"]])
        )
    )
    return(list(KNN = KNN, ind = ind))
}

#' Generate Pseudobulk V(D)J Feature Space
#'
#' This function creates a pseudobulk V(D)J feature space from single-cell data,
#' aggregating V(D)J information into pseudobulk groups. It supports input as
#' either a `Milo` object or a `SingleCellExperiment` object.
#'
#' @param milo A `Milo` or `SingleCellExperiment` object containing V(D)J data.
#' @param pbs Optional. A binary matrix with cells as rows and pseudobulk groups
#'  as columns.
#'  - If `milo` is a `Milo` object, this parameter is not required.
#'  - If `milo` is a `SingleCellExperiment` object, either `pbs` or
#' `col_to_bulk` must be provided.
#' @param col_to_bulk Optional character or character vector. Specifies
#' `colData` column(s) to generate `pbs`. If multiple columns are provided,
#' they will be combined. Default is `NULL`.
#'  - If `milo` is a `Milo` object, this parameter is not required.
#'  - If `milo` is a `SingleCellExperiment` object, either `pbs` or
#' `col_to_bulk` must be provided.
#' @param col_to_take Optional character or vector of characters. Specifies
#' names of colData of milo that need to identify the most common value for each
#'  pseudobulk Default is `NULL`.
#' @param normalise Logical. If `TRUE`, scales the counts of each V(D)J gene
#' group to 1 for each pseudobulk. Default is `TRUE`.
#' @param renormalize Logical. If `TRUE`, rescales the counts of each V(D)J gene
#' group to 1 for each pseudobulk after removing 'missing' calls. Useful when
#' `setupVdjPseudobulk()` was run with `remove_missing = FALSE`.
#' Default is `FALSE`.
#' @param min_count Integer. Sets pseudobulk counts in V(D)J gene groups with
#' fewer than this many non-missing calls to 0. Default is `1`.
#' @param mode_option Character. Specifies the mode for extracting V(D)J genes.
#' Must be one of `c('B', 'abT', 'gdT')`. Default is `'abT'`.
#'   - Note: This parameter is considered only when `extract_cols = NULL`.
#'   - If `NULL`, uses column names such as `v_call_VDJ` instead of
#' `v_call_abT_VDJ`.
#' @param extract_cols Character vector. Specifies column names where V(D)J
#' information is stored. Default is `c('v_call_abT_VDJ_main',
#' 'j_call_abT_VDJ_main', ' 'v_call_abT_VJ_main', 'j_call_abT_VJ_main')`.
#' @param verbose Logical. If `TRUE`, prints messages and warnings.
#' Default is `TRUE`.
#' @details
#' This function aggregates V(D)J data into pseudobulk groups
#' based on the following logic:
#' - **Input Requirements**:
#'  - If `milo` is a `Milo` object, neither `pbs` nor `col_to_bulk` is required.
#'  - If `milo` is a `SingleCellExperiment` object, the user must provide either
#'  `pbs` or `col_to_bulk`.
#' - **Normalization**:
#'  - When `normalise = TRUE`, scales V(D)J counts to 1 for each pseudobulk
#' group.
#'  - When `renormalize = TRUE`, rescales the counts after removing
#' 'missing' calls.
#' - **Mode Selection**:
#'  - If `extract_cols = NULL`, the function relies on `mode_option` to
#' determine which V(D)J columns to extract.
#' - **Filtering**:
#'  - Uses `min_count` to filter pseudobulks with insufficient counts for
#' V(D)J groups.
#'
#' @examples
#' data(sce_vdj)
#' sce_vdj <- setupVdjPseudobulk(sce_vdj,
#'     already.productive = FALSE,
#'     allowed_chain_status = c("Single pair", "Extra pair")
#' )
#' # Build Milo Object
#' milo_object <- miloR::Milo(sce_vdj)
#' milo_object <- miloR::buildGraph(milo_object,
#'     k = 50, d = 20,
#'     reduced.dim = "X_scvi"
#' )
#' milo_object <- miloR::makeNhoods(milo_object,
#'     reduced_dims = "X_scvi",
#'     d = 20
#' )
#'
#' # Construct pseudobulked VDJ feature space
#' pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
#'
#' @return SingleCellExperiment object
#' @include check.R
#' @include getPbs.R
#' @import SingleCellExperiment
#' @importFrom rlang abort
#' @importFrom methods is
#' @importFrom Matrix t
#' @importFrom S4Vectors SimpleList DataFrame
#' @importFrom stats model.matrix contrasts
#' @importFrom miloR Milo
#'
#' @export
vdjPseudobulk <- function(
    milo, pbs = NULL, col_to_bulk = NULL,
    extract_cols = c(
        "v_call_abT_VDJ_main",
        "j_call_abT_VDJ_main",
        "v_call_abT_VJ_main",
        "j_call_abT_VJ_main"
    ),
    mode_option = c(
        "abT",
        "gdT", "B"
    ),
    col_to_take = NULL,
    normalise = TRUE,
    renormalize = FALSE,
    min_count = 1L,
    verbose = TRUE) {
    if (!is(milo, "Milo") && !is(milo, "SingleCellExperiment")) {
        abort("Must be either Milo or SingleCellExperiment object") # nocov
    }
    .classCheck(pbs, "Matrix")
    if (!all(col_to_bulk %in% names(colData(milo)))) {
        abort("col_to_bulk should within the name of coldata of milo") # nocov
    }
    if (!all(col_to_take %in% names(colData(milo)))) {
        abort("col_to_take should within the name of coldata of milo") # nocov
    }
    .typeCheck(normalise, "logical")
    .typeCheck(renormalize, "logical")
    .typeCheck(min_count, "numeric")
    min_count <- as.integer(min_count)
    .typeCheck(mode_option, "character")
    mode_option <- match.arg(mode_option)
    .typeCheck(extract_cols, "character")
    if (is(milo, "Milo")) {
        pbs <- miloR::nhoods(milo)
    } else {
        pbs <- .getPbs(pbs, col_to_bulk, milo, verbose)
    }
    extract_cols <- .determExtractColN(extract_cols, mode_option, milo)
    pseudo_vdj_feature <- .featureSpaceConstruct(milo, extract_cols, pbs)
    if (normalise) {
        pseudo_vdj_feature <- .normalizeFeatureSpace(
            pseudo_vdj_feature,
            extract_cols, min_count, renormalize, milo
        )
    }
    pb.milo <- .packFeatureSpace(pbs, col_to_take, milo, pseudo_vdj_feature)
    return(pb.milo)
}


#' determine the columns in the colData where the main VDJ information is stored
#'
#' @param extract_cols names of columns in the colData where the main VDJ
#' information stores, passed from vdjPseudobulk
#' @param mode_option  Specifies the mode for extracting V(D)J genes
#' @param milo Milo or SingleCellExperiment object provided by user
#' @keywords internal
#' @return a character vector stores the names of columns in the colData where
#' the main VDJ information stores
#' @import SingleCellExperiment
#' @importFrom S4Vectors DataFrame
.determExtractColN <- function(extract_cols, mode_option, milo) {
    if (is.null(extract_cols)) {
        if (is.null(mode_option)) { # nocov start
            all.col.n <- colnames(colData(milo))
            extract_cols <- all.col.n[grep(
                "_call_VDJ_main|_call_VJ_main",
                all.col.n
            )]
        } else {
            all.col.n <- colnames(colData(milo))
            extract_cols <- all.col.n[grep(paste0(
                mode_option, "_VDJ_main|", mode_option,
                "_call_VJ_main"
            ), all.col.n)]
        } # nocov end
    }
    return(extract_cols)
}


#' Construct VDJ feature space
#'
#' @param milo Milo or SingleCellExperiment object provided by user
#' @param extract_cols columns of names where to extract the VDJ information
#' @keywords internal
#' @import SingleCellExperiment
#' @param pbs cell x pseudobulk adjacent matrix
#' @importFrom S4Vectors DataFrame
#' @importFrom stats model.matrix contrasts
#' @importFrom Matrix t
#' @return constructed feature space
.featureSpaceConstruct <- function(milo, extract_cols, pbs) {
    vjs0 <- data.frame(colData(milo)[extract_cols])
    ## model.matrix need factor input
    vjs0[] <- lapply(vjs0, function(x) {
        if (!is.factor(x)) {
            as.factor(x)
        } else {
            x # nocov
        }
    })
    one_hot_encoded <- model.matrix(~ . - 1,
        data = vjs0,
        contrasts.arg = lapply(vjs0,
            contrasts,
            contrasts = FALSE
        )
    ) # prevent reference level
    colnames(one_hot_encoded) <- gsub(
        "^[^.]*\\main", "",
        colnames(one_hot_encoded)
    )
    pseudo_vdj_feature <- t(t(one_hot_encoded) %*% pbs)
    #  an dgeMatrix with dim pseudobulk x vdj
    return(pseudo_vdj_feature)
}


#' Normalize Feature Space
#'
#' Make sure the sum of each V, D, and J gene within a pseudobulk equals to 1
#'
#' @param pseudo_vdj_feature constructed feature space
#' @param extract_cols names of columns to extract the VDJ information
#' @param min_count the minim count of a V/D/J gene
#' @param renormalize Whether to renormalize the matrix
#' @param milo Milo or SingleCellExperiment object provided by user
#' @keywords internal
#' @return normalized VDJ feature space
.normalizeFeatureSpace <- function(
    pseudo_vdj_feature, extract_cols, min_count,
    renormalize, milo) {
    ## identify any missing calls inserted by the setup, will end with
    ## _missing negate as we want to actually remove them later
    define.mask <- rep(TRUE, length(colnames(pseudo_vdj_feature)))
    define.mask[grep("_missing", colnames(pseudo_vdj_feature))] <- FALSE
    # loop over V(D)J categories
    pseudo_vdj_feature <- Reduce(
        function(psef, col_n) {
            .normalizePerVDJ(
                psef, col_n,
                renormalize = renormalize, define.mask = define.mask,
                milo = milo, min_count = min_count
            )
        }, extract_cols,
        init = pseudo_vdj_feature
    )
    return(pseudo_vdj_feature)
}


#' function to normalize a specific kind of VDJ gene in feature space
#'
#' @param pseudo_vdj_feature constructed feature space
#' @param col_n name of column to extract the VDJ information
#' @param renormalize Whether to renormalize the matrix
#' @param define.mask logical vector determine whether the V/D/J gene
#' should be masked when normalizing
#' @param milo Milo or SingleCellExperiment object provided by user
#' @param min_count the minim count of a V/D/J gene
#' @keywords internal
#' @import SingleCellExperiment
#' @return feature space normalized on specifed V/D/J gene
.normalizePerVDJ <- function(
    pseudo_vdj_feature, col_n, renormalize,
    define.mask, milo, min_count) {
    # identify columns holding genes belonging to the category and then
    # normalise the values to 1 for each pseudobulk
    group.mask <- colnames(pseudo_vdj_feature) %in%
        unique(colData(milo)[[col_n]])
    # identify the defined (non-missing) calls for the group
    group.define.mask <- define.mask & group.mask
    # compute sum of of non-missing values for each pseudobulk for this
    # category and compare to the min_count
    define.count <- apply(pseudo_vdj_feature[, group.define.mask], 1, sum)
    defined.min.counts <- define.count >= min_count
    # normalise the pseudobulks
    pseudo_vdj_feature[, group.define.mask] <- pseudo_vdj_feature[
        ,
        group.define.mask
    ] / define.count
    if (renormalize) { # nocov start
        redefine.count <- apply(
            pseudo_vdj_feature[defined.min.counts, group.define.mask],
            1, sum
        )
        pseudo_vdj_feature[
            defined.min.counts,
            group.define.mask
        ] <- pseudo_vdj_feature[
            defined.min.counts,
            group.define.mask
        ] / define.count
    } # nocov end
    pseudo_vdj_feature[!defined.min.counts, group.define.mask] <- 0
    return(pseudo_vdj_feature)
}

#' Pack the normalized feature space into new Milo object
#'
#' The metadata will derived from the original milo
#' @param pbs cell x pseudobulk adjacent matrix
#' @param col_to_take Optional character or vector of characters.
#' Specifies names of colData of milo that need to identify the most
#' common value for each pseudobulk
#' @param milo Milo or SingleCellExperiment object provided by user
#' @param pseudo_vdj_feature VDJ feature space
#' @keywords internal
#' @return Milo object with VDJ feature space stored in its assay
#' @include getPbs.R
#' @import SingleCellExperiment
#' @importFrom miloR Milo
#' @importFrom rlang abort
#' @importFrom Matrix t
#' @importFrom S4Vectors SimpleList DataFrame
.packFeatureSpace <- function(pbs, col_to_take, milo, pseudo_vdj_feature) {
    # create colData for the new pesudobulk object milo@metadata$feature.space
    # <- pseudo_vdj_feature
    pbs.col <- .getPbsCol(pbs, col_to_take = col_to_take, milo = milo)

    # create a new SingelCellExperiment object as result
    pb.sce <- SingleCellExperiment(
        assay = SimpleList(Feature_space = t(pseudo_vdj_feature)),
        rowData = DataFrame(
            row.names =
                colnames(pseudo_vdj_feature)
        ), colData = pbs.col
    )
    # store pseudobulk assignment, as a sparse for storage efficiency transpose
    # as the original matrix is cells x pseudobulks
    pb.milo <- Milo(pb.sce)
    miloR::nhoods(pb.milo) <- t(pbs)
    return(pb.milo)
}

# Mock data for testing
data(sce_vdj)
# downsample to first 2000 cells to speed up the testing.
sce_vdj <- sce_vdj[, 1:2000]
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)

# Build Milo Object
set.seed(100)
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 20, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object, reduced_dims = "X_scvi", d = 20)

# Construct Pseudobulked VDJ Feature Space
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")

# Define root and branch tips
pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
names(branch.tips) <- c("CD8+T", "CD4+T")
root <- which.min(pca[, 1])

# Construct Diffusion Map
dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
# Since the markovProbability will also run in test-projectPseudotimeToCell.R
# as setup, we only consider two special circumstances here.
test_that("markovProbability works correctly with terminal states as NULL", {
    pb.milo <- markovProbability(
        milo = pb.milo,
        diffusionmap = dm,
        terminal_state = NULL,
        diffusiontime = dif.pse[[paste0("DPT", root)]],
        root_cell = root,
        pseudotime_key = "pseudotime"
    )
    expect_true(is(pb.milo, "Milo"))
    expect_true("pseudotime" %in% colnames(colData(pb.milo)))
    expect_true(any(grep("terminal_state", colnames(colData(pb.milo)))))
    expect_false(is.null(metadata(pb.milo)))
})

test_that("markovProbability works correctly with only one terminal state", {
    pb.milo <- markovProbability(
        milo = pb.milo,
        diffusionmap = dm,
        terminal_state = as.numeric(branch.tips[1]),
        diffusiontime = dif.pse[[paste0("DPT", root)]],
        root_cell = root,
        pseudotime_key = "pseudotime"
    )
    expect_true(is(pb.milo, "Milo"))
    expect_true("pseudotime" %in% colnames(colData(pb.milo)))
    expect_true(any(grep("terminal_state", colnames(colData(pb.milo)))))
    expect_false(is.null(metadata(pb.milo)))
})

library(miloR)
library(SingleCellExperiment)

# Mock data for testing
set.seed(100)
data(sce_vdj)
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object, reduced_dims = "X_scvi", d = 20)

# Test for vdjPseudobulk
test_that("vdjPseudobulk works correctly with Milo object", {
    result <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")

    expect_true(is(result, "SingleCellExperiment"))
    expect_true("Feature_space" %in% assayNames(result))
    expect_true(ncol(result) > 0)
    expect_true(nrow(result) > 0)
})

test_that("vdjPseudobulk doesn't work with just any sce object", {
    expect_error(
        vdjPseudobulk(sce_vdj, col_to_bulk = "anno_lvl_2_final_clean"),
        "object 'pbs.col' not found"
    )
})

#' Perform UMAP on the Adjacency Matrix of a Milo Object
#'
#' This function uses `uwot::umap` to perform UMAP dimensionality
#' reduction on the adjacency matrix of the KNN graph in a Milo object.
#'
#' @param milo the milo object with knn graph that needed to conduct umap on.
#' @param slot_name character, with default 'UMAP_knngraph'.
#'  - The slot name in reduceDim where the result store
#' @param n_neighbors integer, with default 50L.
#'  - the size of local neighborhood (in terms of number of
#'   neighboring sample points) used for manifold approximation.
#'  - Here, the goal is to create large enough neighborhoods to capture
#'   the local manifold structure to allow for hypersampling.
#' @param metric character, with default 'euclidean'
#'  - the choice of metric used to measure distance to find nearest neighbors.
#'   Default is 'euclidean'.
#' @param min_dist numeric, with default 0.3
#'  - the minimum distance between points in the low dimensional space
#' @param use_graph Logical, default TRUE.
#'   - Whether to run UMAP on the graph adjacency matrix (TRUE) as in Dandelion,
#'     or directly on the latent space (FALSE) for faster performance.
#' @param ... other parameters passed to uwot::umap
#' @examples
#' data(sce_vdj)
#' # downsample to just 1000 cells
#' sce_vdj <- sce_vdj[, 1:1000]
#' sce_vdj <- setupVdjPseudobulk(sce_vdj,
#'     already.productive = FALSE,
#'     allowed_chain_status = c("Single pair", "Extra pair")
#' )
#' # Build Milo Object
#' milo_object <- miloR::Milo(sce_vdj)
#' milo_object <- miloR::buildGraph(milo_object,
#'     k = 50, d = 20,
#'     reduced.dim = "X_scvi"
#' )
#' milo_object <- miloR::makeNhoods(milo_object,
#'     reduced_dims = "X_scvi", d = 20
#' )
#'
#' # Construct UMAP on Milo Neighbor Graph
#' milo_object <- miloUmap(milo_object)
#'
#' @return milo object with umap reduction
#' @import SingleCellExperiment
#' @importFrom igraph as_adjacency_matrix
#' @importFrom miloR graph
#' @importFrom uwot umap
#' @export
miloUmap <- function(
    milo, slot_name = "UMAP_knngraph", n_neighbors = 50L, metric = "euclidean",
    min_dist = 0.3, use_graph = TRUE, ...) {
    if (use_graph) {
        # get the graph's adjacency matrix
        graphm <- as_adjacency_matrix(graph(milo), sparse = TRUE)
        # inherit the names of each row
        rownames(graphm) <- rownames(colData(milo))
        colnames(graphm) <- rownames(colData(milo))
    } else {
        graphm <- reducedDim(milo_object, "X_scvi")
    }
    # conduct umap
    pos <- umap(graphm,
        n_neighbors = n_neighbors, metric = metric, min_dist = min_dist,
        ...
    )
    reducedDim(milo, slot_name) <- pos
    return(milo)
}

library(scRepertoire)
library(miloR)
data(demo_sce)
data(demo_airr)

contig.list <- loadContigs(input = demo_airr, format = "AIRR")

# Format to `scRepertoire`'s requirements and some light filtering
combined.TCR <- combineTCR(contig.list,
    removeNA = TRUE,
    removeMulti = FALSE,
    filterMulti = TRUE
)

sce <- combineExpression(combined.TCR, demo_sce)
sce <- setupVdjPseudobulk(sce,
    mode_option = "abT",
    already.productive = TRUE,
    subsetby = "anno_lvl_2_final_clean",
    groups = c("CD8+T", "CD4+T", "ABT(ENTRY)", "DP(P)_T", "DP(Q)_T")
)

# Build Milo Object
milo_object <- Milo(sce)
milo_object <- buildGraph(milo_object, k = 30, d = 20, reduced.dim = "X_scvi")
milo_object <- makeNhoods(milo_object,
    reduced_dims = "X_scvi", d = 20,
    prop = 0.3
)

# Test for miloUmap
test_that("miloUmap works correctly", {
    result <- miloUmap(milo_object, n_neighbors = 30)

    expect_true(is(result, "Milo"))
    expect_true("UMAP_knngraph" %in% reducedDimNames(result))
    expect_equal(ncol(reducedDim(result, "UMAP_knngraph")), 2)
})

#' Compute Branch Probabilities Using Markov Chain
#'
#' This function calculates branch probabilities for differentiation
#' trajectories based on a Markov chain constructed from waypoint data and
#' pseudotime ordering.
#'
#' @param wp_data A multi-scale data matrix or data frame representing the
#' waypoints.
#' @param terminal_states Integer vector. Indices of the terminal states.
#' Default is `NULL`.
#' @param knn Integer. Number of nearest neighbors for graph construction.
#' Default is `30L`.
#' @param pseudotime Numeric vector. Pseudotime ordering of cells.
#' @param waypoints Integer vector. Indices of selected waypoints used to
#' construct the Markov chain.
#' @param verbose Boolean, whether to print messages/warnings.
#' @param use_RANN parameter to make user choose
#' whether to use RANN to construct Markov chain,
#' or keep using bluster
#' @return A numeric matrix or data frame containing branch probabilities
#' for each waypoint.
#' @importFrom Matrix solve
#' @importFrom MASS ginv
#' @include constructMarkovChain.R
#' @include terminalStateFromMarkovChain.R
differentiationProbabilities <- function(
    wp_data, terminal_states = NULL,
    knn = 30L, pseudotime, waypoints, verbose = TRUE, use_RANN = TRUE) {
    T_ <- .constructMarkovChain(
        wp_data, knn, pseudotime,
        waypoints, verbose, use_RANN
    )
    if (is.null(terminal_states)) {
        terminal_states <- .terminalStateFromMarkovChain(
            T_, wp_data, pseudotime,
            waypoints, verbose
        )
    }
    abs_states_idx <- which(waypoints %in% terminal_states)
    T_[abs_states_idx, ] <- 0
    T_ <- Reduce(function(matri, x) {
        matri[x, x] <- 1
        return(matri)
    }, x = abs_states_idx, init = T_)
    if (verbose) {
        message(
            c(
                "Computing fundamental matrix and ",
                "absorption probabilities..."
            )
        )
    }
    trans_states_idx <- which(!(waypoints %in% terminal_states))
    Q <- T_[-abs_states_idx, -abs_states_idx]
    mat <- diag(dim(Q)[[1]]) - Q
    N <- tryCatch(solve(mat), error = function(e) {
        if (verbose) {
            warning(
                c(
                    "Matrix generated is singular or nearly singular;",
                    " using pseudo-inverse to construct fundamental matrix."
                )
            )
        }
        ginv(as.matrix(mat))
    })
    R <- T_[trans_states_idx, abs_states_idx]
    probabilities <- N %*% R
    if (dim(probabilities)[[2]] > 1) {
        probabilities@x[probabilities@x < 0] <- 0
    } else {
        probabilities[probabilities < 0] <- 0
    }
    # add terminal states
    probabilities <- rbind(probabilities, T_[abs_states_idx, abs_states_idx])
    probabilities <- probabilities[order(c(trans_states_idx, abs_states_idx)), ]
    return(list(probabilities, terminal_states))
}

#' Preprocess V(D)J Data for Pseudobulk Analysis
#'
#' This function preprocesses single-cell V(D)J sequencing data for
#' pseudobulk analysis. It filters data based on productivity and chain status,
#' subsets data, extracts main V(D)J genes, and removes unmapped entries.
#'
#' @param sce A `SingleCellExperiment` object. V(D)J data should be contained
#'  in `colData` for filtering.
#' @param mode_option Optional character. Specifies the mode for extracting
#'  V(D)J genes.
#' If `NULL`, `extract_cols` must be specified. Default is `NULL`.
#' @param already.productive Logical. Whether the data has already been filtered
#'  for productivity.
#' If `TRUE`, skips productivity filtering. Default is `FALSE`.
#' @param productive_cols Character vector. Names of `colData` columns used for
#'  productivity filtering.
#' Default is `NULL`.
#' @param productive_vj Logical. If `TRUE`, retains cells where the main
#'  VJ chain is productive.
#'  Default is `TRUE`.
#' @param productive_vdj Logical. If `TRUE`, retains cells where the
#'  main VDJ chain is productive.
#' Default is `TRUE`.
#' @param allowed_chain_status Character vector. Specifies chain statuses to
#'  retain. Valid options
#' include\code{`c('single pair', 'Extra pair', 'Extra pair-exception',
#' 'Orphan VDJ', 'Orphan VDJ-exception')`}. Default is `NULL`.
#' @param subsetby Character. Name of a `colData` column for subsetting.
#'  Default is `NULL`.
#' @param groups Character vector. Specifies the subset condition for filtering.
#'  Default is `NULL`.
#' @param extract_cols Character vector. Names of `colData` columns where V(D)J
#'  information is
#' stored, used instead of the standard columns. Default is `NULL`.
#' @param filter_unmapped Logic. Whether to filter unmapped data. Default
#'  is TRUE.
#' @param check_vj_mapping Logic vector. Whether to check for VJ mapping.
#'  Default is `c(TRUE, TRUE)`.
#'  - If the first element is TRUE, function will filter the unmapped data in V
#'   gene of the VJ chain
#'  - If the second element is TRUE, function will filter the unmapped data in J
#'   gene of the VJ chain
#' @param check_vdj_mapping Logic vector. Specifies columns to check for
#'  VDJ mapping. Default
#' is `c(TRUE, FALSE, 'TRUE)`.
#'  - If the first element is TRUE, function will filter the unmapped data in V
#'   gene of the VDJ chain
#'  - If the second element is TRUE, function will filter the unmapped data in D
#'   gene of the VDJ chain
#'  - If the third element is TRUE, function will filter the unmapped data in J
#'   gene of the VDJ chain
#' @param check_extract_cols_mapping Character vector. Specifies columns related
#'  to `extract_cols`
#' for mapping checks. Default is `NULL`.
#' @param remove_missing Logical. If `TRUE`, removes cells with contigs matching
#'  the filter.
#' If `FALSE`, masks them with uniform values. Default is `TRUE`.
#' @param verbose Logical. Whether to print messages. Default is `TRUE`.

#' @details
#' The function performs the following preprocessing steps:
#' - **Productivity Filtering**:
#'   - Skipped if `already.productive = TRUE`.
#'   - Filters cells based on productivity using `productive_cols` or standard
#'   `colData` columns named `productive_{mode_option}_{type}` (where `type`
#'   is 'VDJ' or 'VJ').
#'   - *mode_option*
#'      - function will check colData(s) named
#'      `productive_{mode_option}_{type}`, where type should be 'VDJ' or 'VJ'
#'      or both, depending on values of productive_vj and productive_vdj.
#'      - If set as `NULl`, the function needs the option 'extract_cols' to be
#'       specified
#'   - *productive_cols*
#'      - must be be specified when productivity filtering is need to conduct
#'       and mode_option is NULL.
#'      - where VDJ/VJ information is stored so that this will be used
#'       instead of the standard columns.
#'   - *productive_vj, productive_vdj*
#'      - If `TRUE`, cell will only be kept if the main V(D)J chain
#'       is productive
#' - **Chain Status Filtering**:
#'   - Retains cells with chain statuses specified by `allowed_chain_status`.
#' - **Subsetting**:
#'   - Conducted only if both `subsetby` and `groups` are provided.
#'   - Retains cells matching the `groups` condition in the `subsetby` column.
#' - **Main V(D)J Extraction**:
#'   - Uses `extract_cols` to specify custom columns for
#'    extracting V(D)J information.
#' - **Unmapped Data Filtering**:
#'   - decided to removes or masks cells based on `filter_unmapped`.
#'   - Checks specific columns for unclear mappings using `check_vj_mapping`,
#'    `check_vdj_mapping`, or `check_extract_cols_mapping`.
#'   - *filter_unmapped*
#'      - pattern to be filtered from object.
#'      - If is set to be `NULL`, the filtering process will not start
#'   - *check_vj_mapping, check_vdj_mapping*
#'      - only `colData` specified by these arguments
#'       (`check_vj_mapping` and `check_vdj_mapping`) will be checked
#'        for unclear mappings
#'   - *check_extract_cols_mapping, related to extract_cols*
#'      - Only `colData` specified by the argument will be checked for
#'      unclear mapping, the colData should first specified by extract_cols
#'   - remove_missing
#'      - If `TRUE`, will remove cells with contigs matching the filter from the
#'       object.
#'      - If `FALSE`, will mask them with a uniform value dependent on
#'      the column name.
#' @include check.R
#' @include filterCells.R
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @importFrom rlang abort
#' @return filtered SingleCellExperiment object
#' @examples
#'
#' # load data
#' data(sce_vdj)
#' # check the dimension
#' dim(sce_vdj)
#' # filtered the data
#' sce_vdj <- setupVdjPseudobulk(
#'     sce = sce_vdj,
#'     mode_option = "abT", # set the mode to alpha-beta TCR
#'     allowed_chain_status = c("Single pair", "Extra pair"),
#'     already.productive = FALSE
#' ) # need to filter the unproductive cells
#' # check the remaining dim
#' dim(sce_vdj)
#'
#' @export
setupVdjPseudobulk <- function(
    sce,
    mode_option = c("abT", "gdT", "B"),
    already.productive = TRUE,
    productive_cols = NULL, productive_vj = TRUE,
    productive_vdj = TRUE,
    allowed_chain_status = NULL, subsetby = NULL,
    groups = NULL, extract_cols = NULL,
    filter_unmapped = TRUE,
    check_vj_mapping = c(TRUE, TRUE),
    check_vdj_mapping = c(TRUE, FALSE, TRUE),
    check_extract_cols_mapping = NULL,
    remove_missing = TRUE,
    verbose = TRUE) {
    # check if the data type is correct
    .classCheck(sce, "SingleCellExperiment")
    mode_option <- match.arg(mode_option)
    .typeCheck(productive_cols, "character")
    .typeCheck(productive_vdj, "logical")
    .typeCheck(productive_vj, "logical")
    .typeCheck(extract_cols, "character")
    .typeCheck(filter_unmapped, "logical")
    ## filter out cells with unproductive chain
    if (!already.productive) {
        sce <- .filterProductivity(
            sce, mode_option, productive_cols,
            productive_vj, productive_vdj, verbose
        )
    }
    ## retain only cells with allowed chain status
    sce <- .allowedChain(sce, allowed_chain_status, verbose)
    ## subset sce by subsetby and groups
    sce <- .subsetSce(sce, subsetby, groups, verbose)
    ## extract main VDJ from specified columns
    if (verbose) message("VDJ data extraction begin:")
    sce <- .extractVdj(sce, extract_cols, mode_option, verbose)
    # remove unclear mapping
    if (filter_unmapped) {
        sce <- .filterUnmapped(
            sce$sce, mode_option, check_vj_mapping,
            check_vdj_mapping,
            sce$main_cols,
            check_extract_cols_mapping, remove_missing, verbose
        )
    } else {
        sce <- sce$sce
    }
    if (verbose) message(sprintf("%d of cells remain.", dim(sce)[2]))
    return(sce)
}

#' filer out cell with unproductive chain
#'
#' @param sce SingleCellExperiment input
#' @param mode_option check setupVdjPseudobulk for detailed explanation
#' @param productive_vj If `TRUE`, retains cells where the main VJ chain is
#'  productive.
#' @param productive_vdj If `TRUE`, retains cells where the main VDJ chain is
#'  productive.
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @include check.R
#' @import SingleCellExperiment
#' @importFrom rlang abort
#' @return SingleCellExperiment object after filtering on producive chain
.filterProductivity <- function(sce, mode_option, productive_cols,
                                productive_vj, productive_vdj, verbose) {
    if (is.null(mode_option)) {
        if (!is.null(productive_cols)) { # nocov start
            msg <- paste(productive_cols, collapse = ", ")
            if (verbose) {
                message(sprintf("Checking productivity from %s ..."),
                    appendLF = FALSE
                )
            }
            cnumber0 <- dim(sce)[2]
            sce <- Reduce(function(data, p_col) {
                idx <- substr(colData(data)[[p_col]],
                    start = 1,
                    stop = 1
                ) == "T"
                data[, idx]
            }, productive_cols, init = sce)
            cnumber1 <- dim(sce)[2]
            if (verbose) {
                message(sprintf("%d of cells filtered", cnumber0 - cnumber1))
            }
        } else {
            abort(sprintf("Specify productive_cols %s when mode_option = NULL"))
        } # nocov end
    } else {
        if (is.null(productive_cols)) {
            produ_col <- paste("productive", mode_option, c("VDJ", "VJ"),
                sep = "_"
            )[c(productive_vdj, productive_vj)]
        } else {
            produ_col <- productive_cols
        }
        msg <- paste(produ_col, collapse = ", ")
        if (verbose) {
            message(sprintf("Checking productivity from %s ...", msg),
                appendLF = FALSE
            )
        }
        cnum0 <- dim(sce)[2]
        sce <- Reduce(function(data, p_col) {
            idx <- substr(colData(data)[[p_col]], start = 1, stop = 1) == "T"
            data[, idx]
        }, produ_col, init = sce)
        cnum1 <- dim(sce)[2]
        if (verbose) message(sprintf("%d of cells filtered", cnum0 - cnum1))
    }
    return(sce)
}

#' filtering cell without allowed chain status
#'
#' @param sce SingleCellExperiment object input
#' @param allowed_chain_status the chain needs to be retain, passed from
#'  setupVdjPseudobulk
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @import SingleCellExperiment
#' @importFrom rlang abort
#' @return SingleCellExperiment object with allowed chain status
.allowedChain <- function(sce, allowed_chain_status, verbose) {
    ## retain only cells with allowed chain status
    if (!is.null(allowed_chain_status)) {
        if (verbose) message("checking allowed chains...", appendLF = FALSE)
        cnumber0 <- dim(sce)[2]
        idx <- colData(sce)[["chain_status"]] %in% allowed_chain_status
        if (!any(idx)) {
            allowed_cs <- paste(allowed_chain_status, collapse = ", ")
            current_cs <- paste(unique(colData(sce)[["chain_status"]]),
                collapse = ", "
            )
            abort(sprintf(
                paste0(
                    "Unsuitable allowed_chain_status,\n ",
                    "The current allowed_chain_status: %s.\n ",
                    "While the chain status in the dataset: %s."
                ),
                allowed_cs, current_cs
            ))
        }
        sce <- sce[, idx]
        cnumber1 <- dim(sce)[2]
        filtered <- cnumber0 - cnumber1
        if (verbose) message(sprintf("%d of cells filtered", filtered))
    }
    return(sce)
}
#' Subset sce with given parameter
#'
#' @param sce SingleCellExperiment object input
#' @param subsetby subsetby Character. Name of a `colData` column for
#'  subsetting. given by setupVdjPsudobulk.
#' @param groups Character vector. Specifies the subset condition for filtering.
#'  given by setupVdjPsudobulk.
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @import SingleCellExperiment
#' @importFrom rlang abort
#' @return subsetted SingleCellExperiment object
.subsetSce <- function(sce, subsetby, groups, verbose) {
    .typeCheck(subsetby, "character")
    .typeCheck(groups, "character")
    if (!is.null(groups) && !is.null(subsetby)) {
        msg1 <- paste(as.character(substitute(groups))[-1], collapse = ", ")
        msg2 <- as.character(substitute(subsetby))
        if (verbose) {
            message(sprintf("Subsetting data with %s in %s ...", msg1, msg2),
                appendLF = FALSE
            )
        }
        cnumber0 <- dim(sce)[2]
        idx <- Reduce(`|`, lapply(groups, function(i) {
            colData(sce)[[subsetby]] %in% i
        }))
        sce <- sce[, idx]
        cnumber1 <- dim(sce)[2]
        filtered <- cnumber0 - cnumber1
        if (verbose) message(sprintf("%d of cells filtered", filtered))
    }
    return(sce)
}
#' Specify the columns which store VDJ information, and extract the main chain
#'  from it
#'
#' @param sce SingleCellExperiment object input
#' @param extract_cols The setupVdjPseutobulk transfered parameter given by user
#'  to specify the VDJ information columns
#' @param mode_option see document of setupVdjPseudobulk for
#'  detailed explanation
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @importFrom rlang abort
#' @return SingleCellExperiment objects with column stores the information of
#'  the main VDJ information in colData slot
.extractVdj <- function(sce, extract_cols, mode_option, verbose) {
    # generate colnames to extract
    if (is.null(extract_cols)) {
        extract_cols <- .generateExtractName(sce, mode_option, verbose)
    }
    # make sure the columns exist
    sce <- .generateExtractColumn(sce, extract_cols, verbose)
    # extract main information
    if (!length(grep("_VDJ_main|_VJ_main", names(colData(sce))))) {
        colns <- paste(extract_cols, collapse = ", ")
        if (verbose) {
            message(sprintf("Extract main TCR from %s ...", colns),
                appendLF = FALSE
            )
        }
        sce <- Reduce(function(data, ex_col) {
            tem <- colData(data)[[ex_col]]
            strtem <- strsplit(as.character(tem), "\\|")
            value_need <- vapply(strtem, `[`, 1, FUN.VALUE = character(1))
            colData(data)[[paste(ex_col, "main", sep = "_")]] <- value_need
            data
        }, extract_cols, init = sce)
        main_cols <- paste(extract_cols, "main", sep = "_")
        if (verbose) message("Complete.")
    } else {
        main_cols <- colnames(colData(sce))[grep(
            "_VDJ_main|_VJ_main",
            names(colData(sce))
        )]
        if (verbose) {
            warning(
                c(
                    "main VDJ information already exists,",
                    "Instead of using 'check_v(d)j_mapping', please use",
                    "the argument 'check_extract_cols_mapping'",
                    "to clarify the columns undergo filtering."
                )
            )
        }
    }
    return(list(sce = sce, main_cols = main_cols))
}
#' Generate the name of columns with given parameter
#'
#' @param sce SingleCellExperiment object input
#' @param mode_option see document of setupVdjPseudobulk for explanation
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @return a vecotor of colnames we need to perform main chain extraction
.generateExtractName <- function(sce, mode_option, verbose) {
    if (verbose) {
        message(c(
            "extract_cols not specified, automatically generate",
            " colnames for extraction."
        ))
    }
    v_call <- if ("v_call_genotyped_VDJ" %in% colnames(colData(sce))) {
        # nocov start
        "v_call_genotyped_" # nocov end
    } else {
        "v_call_"
    }
    prefix <- c(v_call, "d_call_", "j_call_")
    if (!is.null(mode_option)) {
        # can be pack as another function
        suffix <- c("_VJ", "_VDJ")
        extr_cols <- as.vector(outer(prefix, suffix, function(x, y) {
            paste0(x, mode_option, y)
        }))
        extr_cols <- extr_cols[extr_cols != paste0(
            "d_call_", mode_option,
            "_VJ"
        )]
    } else {
        # nocov start
        suffix <- c("VJ", "VDJ")
        extr_cols <- as.vector(outer(prefix, suffix, function(x, y) {
            paste0(x, y)
        }))
        extr_cols <- extr_cols[extr_cols != paste0("d_call_", "VJ")]
        # nocov end
    }
    return(extr_cols)
}
#' Check whether the columns with specified names exist, if not, create them
#' with CTgene columns
#' @param sce SingleCellExperiment object input
#' @param extract_cols column names we aim to extract information from
#' @param verbose logical, print messages. Default is `TRUE`.
#' @keywords internal
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @importFrom rlang abort
#' @return SingleCellExperiment with columns containing VDJ information in the
#' names we've specified.
.generateExtractColumn <- function(sce, extract_cols, verbose) {
    msg <- paste(extract_cols, collapse = ", ")
    if (!any(extract_cols %in% colnames(colData(sce)))) {
        if (verbose) {
            message(sprintf(
                "ColData does not exist, Creating %s %s",
                msg, "colData based on column CTgene"
            ))
        }
        if (!"CTgene" %in% colnames(colData(sce))) {
            abort(sprintf(paste(
                "Both %s and CTgene do not exist\n You could modify parameter",
                "extract_cols to clarify VDJ information's location"
            ), msg))
        }
        splitVdj <- splitCTgene(sce)
        if (length(splitVdj[[1]]) != length(extract_cols)) {
            abort(
                sprintf(paste(
                    "Colnames %s must have the same length with the",
                    "vdj data, which is of length %d.\n Modify",
                    "`extract_cols`` to specify the TCR columns."
                )),
                paste0(extract_cols[!extract_cols %in% colnames(colData(sce))],
                    collapse = ", "
                ),
                length(splitVdj[[1]])
            )
        } else {
            vdj <- lapply(seq(length(extract_cols)), function(X, sc) {
                vapply(X = sc, "[", X, FUN.VALUE = character(1))
            }, sc = splitVdj)
            names(vdj) <- extract_cols
            colData(sce) <- cbind(colData(sce), vdj)
        }
    } else if (!all(extract_cols %in% colnames(colData(sce)))) {
        abort(sprintf(
            paste0(
                "Colnames %s do not exist in colData.\n Use",
                "`extract_cols` to specify the TCR columns."
            ),
            paste0(
                extract_cols[!extract_cols %in% colnames(colData(sce))],
                collapse = ", "
            )
        ))
    }
    return(sce)
}
#' Filter out cell with unclear mapping in VDJ information
#' @param sce SingleCellExperiment object input
#' @param mode_option see document of setupVdjPseudobulk for explanation
#' @param check_vj_mapping logical vector to set whether to check V and J gene
#' in VJ chain, passed from setupVdjPseudobulk
#' @param check_vdj_mapping logical vector to set whether to check
#' V, D and J gene in VDJ chain, passed from setupVdjPseudobulk
#' @param main_cols column names in colData in which The information of
#' main chain stores
#' @param check_extract_cols_mapping character vector,the names of columns that
#'  needs to be checked, passed from setupVdjPseudobulk
#' @param remove_missing option for removing the unclear mappin or just mask it,
#' passed from setupVdjPseudobulk
#' @param verbose logical, print messages.
#' @keywords internal
#' @include filterCells.R
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @importFrom rlang abort
#' @return filtered SingleCellExperiment object
.filterUnmapped <- function(sce, mode_option, check_vj_mapping,
                            check_vdj_mapping, main_cols,
                            check_extract_cols_mapping, remove_missing,
                            verbose) {
    .typeCheck(check_vj_mapping, "logical")
    if (length(check_vj_mapping) != 2) {
        abort(sprintf(
            paste0(
                "ValueError: length of check_vj_mapping should be",
                " 2. But %d was provided."
            ),
            length(check_vj_mapping)
        )) # nocov
    }
    .typeCheck(check_vdj_mapping, "logical")
    if (length(check_vdj_mapping) != 3) {
        abort(sprintf(paste0(
            "ValueError: length of check_vj_mapping should be",
            " 3. But %d was provided."
        ), length(check_vdj_mapping))) # nocov
    }
    .typeCheck(check_extract_cols_mapping, "character")
    .typeCheck(remove_missing, "logical")
    filter_pattern <- ",|None|No_contig"
    extr_cols <- c()
    if (is.null(check_extract_cols_mapping)) {
        extr_cols <- main_cols[c(check_vj_mapping, check_vdj_mapping)]
    } else {
        extr_cols <- check_extract_cols_mapping
    }
    if (!is.null(extr_cols)) {
        msg <- paste(extr_cols, collapse = ", ")
        if (verbose) {
            message(sprintf("Filtering cells from %s ...", msg),
                appendLF = FALSE
            )
        }
        cnumber0 <- dim(sce)[2]
        sce <- Reduce(function(x, y) {
            .filterCells(
                sce = x, col_n = y, filter_pattern = filter_pattern,
                remove_missing = remove_missing
            )
        }, extr_cols, init = sce)
        cnumber1 <- dim(sce)[2]
        filtered <- cnumber0 - cnumber1
        if (verbose) message(sprintf("%d of cells filtered", filtered))
    }
    return(sce)
}

library(SingleCellExperiment)

# Mock data for testing
library(dandelionR)
library(scRepertoire)

data(demo_sce)
data(demo_airr)

contig.list <- loadContigs(input = demo_airr, format = "AIRR")

# Format to `scRepertoire`'s requirements and some light filtering
combined.TCR <- combineTCR(contig.list,
    removeNA = TRUE,
    removeMulti = FALSE,
    filterMulti = TRUE
)
sce <- combineExpression(combined.TCR, demo_sce)

# Test for setupVdjPseudobulk
test_that("setupVdjPseudobulk works correctly", {
    result <- setupVdjPseudobulk(sce,
        mode_option = "abT",
        already.productive = TRUE,
        subsetby = "anno_lvl_2_final_clean",
        groups = c("CD8+T", "CD4+T", "ABT(ENTRY)", "DP(P)_T", "DP(Q)_T")
    )

    expect_true(is(result, "SingleCellExperiment"))
    expect_true(ncol(result) <= ncol(sce))
    expect_true(all(colData(result)$anno_lvl_2_final_clean %in% c(
        "CD8+T",
        "CD4+T", "ABT(ENTRY)", "DP(P)_T", "DP(Q)_T"
    )))
})

library(SingleCellExperiment)

# Mock data for testing
set.seed(100)
data(sce_vdj)

# Test for setupVdjPseudobulk
test_that("setupVdjPseudobulk works correctly with mode_option", {
    result <- setupVdjPseudobulk(
        sce = sce_vdj,
        mode_option = "abT",
        already.productive = FALSE,
        productive_cols = NULL,
        productive_vj = TRUE,
        productive_vdj = TRUE,
        allowed_chain_status = c("Single pair", "Extra pair")
    )

    expect_true(is(result, "SingleCellExperiment"))
    expect_true(ncol(result) <= ncol(sce_vdj))
})

test_that("setupVdjPseudobulk works correctly with productive_cols", {
    result <- setupVdjPseudobulk(
        sce = sce_vdj,
        mode_option = NULL,
        already.productive = FALSE,
        productive_cols = c("productive_abT_VDJ", "productive_abT_VJ"),
        productive_vj = TRUE,
        productive_vdj = TRUE,
        allowed_chain_status = c("Single pair", "Extra pair")
    )

    expect_true(is(result, "SingleCellExperiment"))
    expect_true(ncol(result) <= ncol(sce_vdj))
})

test_that("setupVdjPseudobulk handles allowed_chain_status correctly", {
    result <- setupVdjPseudobulk(
        sce = sce_vdj,
        mode_option = "abT",
        already.productive = TRUE,
        allowed_chain_status = c("Single pair")
    )

    expect_true(is(result, "SingleCellExperiment"))
    expect_true(all(colData(result)$chain_status == "Single pair"))
})

test_that(sprintf(
    "setupVdjPseudobulk throws error when no cells match %s",
    "allowed_chain_status"
), {
    expect_error(setupVdjPseudobulk(
        sce = sce_vdj,
        mode_option = "abT",
        already.productive = TRUE,
        allowed_chain_status = c("Non-existent status")
    ), "Unsuitable allowed_chain_status")
})

#' minMaxScale
#'
#' scale the value to range 0 to 1
#' @param data dataframe need to be scale
#' @keywords internal
#' @returns scaled value
.minMaxScale <- function(data) {
    maxv <- apply(data, 2, max)
    minv <- apply(data, 2, min)
    data_scale <- apply(data, 1, `-`, minv) / (maxv - minv)
    return(t(data_scale))
}

# Mock data for testing
set.seed(100)
data <- matrix(abs(rnorm(100)), ncol = 10)

# Test for .minMaxScale
test_that(".minMaxScale works correctly", {
    result <- .minMaxScale(data)

    expect_true(is.matrix(result))
    expect_equal(dim(result), dim(data))
    expect_true(all(result >= 0 & result <= 1))

    # Check if the minimum value in each column is 0 and the maximum value is 1
    expect_equal(apply(result, 2, min), rep(0, ncol(data)))
    expect_equal(apply(result, 2, max), rep(1, ncol(data)))
})

# Additional tests for edge cases
test_that(".minMaxScale handles edge cases", {
    # Test with single column data
    single_col_data <- matrix(abs(rnorm(10)), ncol = 1)
    result_single_col <- .minMaxScale(single_col_data)
    expect_true(is.matrix(result_single_col))
    expect_equal(dim(result_single_col), rev(dim(single_col_data)))
    expect_true(all(result_single_col >= 0 & result_single_col <= 1))

    # Test with single row data
    single_row_data <- matrix(abs(rnorm(10)), nrow = 1)
    result_single_row <- .minMaxScale(single_row_data)
    expect_true(all(is.na(result_single_row)))

    # Test with constant data
    constant_data <- matrix(rep(5, 100), ncol = 10)
    result_constant <- .minMaxScale(constant_data)
    expect_true(is.matrix(result_constant))
    expect_equal(dim(result_constant), dim(constant_data))
    expect_true(all(is.na(result_constant)))
})

#' .classCheck
#'
#' check whether the input is with the correct class
#' @param input the input need to be check
#' @param must the type we need
#' @keywords internal
#' @importFrom rlang abort
#' @importFrom methods is
#' @return whether or not the input is the correct class
.classCheck <- function(input, must) {
    if (is.null(input)) {
        return()
    }
    if (!is(input, must)) {
        abort(sprintf(
            "The '%s' must be %s, not %s",
            as.character(substitute(input)), must, class(input)
        ))
    }
}


#' .typeCheck
#'
#' check whether the input has the correct type
#' @param input the input need to be check
#' @param must the type we need
#' @keywords internal
#' @importFrom rlang abort
#' @importFrom methods is
#' @importFrom BiocGenerics type
#' @return whether or not the input is the correct type
.typeCheck <- function(input, must) {
    if (is.null(input)) {
        return()
    }
    if (!is(input, must)) {
        abort(sprintf(
            "The '%s' must be %s, not %s",
            as.character(substitute(input)), must, type(input)
        ))
    }
}

library(rlang)
library(methods)
library(BiocGenerics)

# Test for .classCheck
test_that(".classCheck works correctly", {
    expect_error(.classCheck(NULL, "character"), NA)
    expect_error(.classCheck("test", "character"), NA)
    expect_error(
        .classCheck(123, "character"),
        "The '123' must be character, not numeric"
    )
    expect_error(.classCheck(TRUE, "logical"), NA)
    expect_error(
        .classCheck("test", "logical"),
        "The 'test' must be logical, not character"
    )
})

# Test for .typeCheck
test_that(".typeCheck works correctly", {
    expect_error(.typeCheck(NULL, "character"), NA)
    expect_error(.typeCheck("test", "character"), NA)
    expect_error(
        .typeCheck(123, "character"),
        "The '123' must be character, not double"
    )
    expect_error(.typeCheck(TRUE, "logical"), NA)
    expect_error(
        .typeCheck("test", "logical"),
        "The 'test' must be logical, not character"
    )
})

# Additional tests for edge cases
test_that(".classCheck handles edge cases", {
    expect_error(.classCheck(list(), "list"), NA)
    expect_error(.classCheck(data.frame(), "data.frame"), NA)
    expect_error(.classCheck(matrix(), "matrix"), NA)
})

test_that(".typeCheck handles edge cases", {
    expect_error(.typeCheck(list(), "list"), NA)
    expect_error(.typeCheck(data.frame(), "data.frame"), NA)
    expect_error(.typeCheck(matrix(), "matrix"), NA)
})

#' Markov Chain Construction and Probability Calculation
#'
#' This function preprocesses data, constructs a Markov chain, and calculates
#' transition probabilities based on pseudotime information.
#' @param milo A `Milo` or `SingleCellExperiment` object. This object should
#' have pseudotime stored in `colData`, which will be used to calculate
#' probabilities. If pseudotime is available in `milo`, it takes precedence over
#'  the value provided through the `diffusiontime` parameter.
#' @param terminal_state Integer. The index of the terminal state in the Markov
#' chain.
#' @param root_cell Integer. The index of the root state in the Markov chain.
#' @param knn Integer. The number of nearest neighbors for graph construction.
#' Default is `30L`.
#' @param diffusionmap A `DiffusionMap` object corresponding to the `milo`
#' object. Used for Markov chain construction.
#' @param diffusiontime Numeric vector. If pseudotime is not stored in `milo`,
#' this parameter can be used to provide pseudotime values to the function.
#' @param pseudotime_key Character. The name of the column in `colData` that
#' contains the inferred pseudotime.
#' @param scale_components Logical. If `TRUE`, the components will be scaled
#' before constructing the Markov chain. Default is `FALSE`.
#' @param num_waypoints Integer. The number of waypoints to sample when
#' constructing the Markov chain. Default is `500L`.
#' @param n_eigs integer, default is NULL. Number of eigen vectors to use.
#' - If is not specified, the number of eigen vectors will be determined using
#'  the eigen gap.
#' @param verbose Logical. If `TRUE`, print progress. Default is `TRUE`.
#' @param use_RANN parameter to make user choose
#' whether to use RANN to construct Markov chain,
#' or keep using bluster
#' @examples
#' data(sce_vdj)
#' # downsample to first 2000 cells
#' sce_vdj <- sce_vdj[, 1:2000]
#' sce_vdj <- setupVdjPseudobulk(sce_vdj,
#'     already.productive = FALSE,
#'     allowed_chain_status = c("Single pair", "Extra pair")
#' )
#' # Build Milo Object
#' set.seed(100)
#' milo_object <- miloR::Milo(sce_vdj)
#' milo_object <- miloR::buildGraph(milo_object,
#'     k = 50, d = 20,
#'     reduced.dim = "X_scvi"
#' )
#' milo_object <- miloR::makeNhoods(milo_object,
#'     reduced_dims = "X_scvi",
#'     d = 20
#' )
#'
#' # Construct Pseudobulked VDJ Feature Space
#' pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
#' pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")
#'
#' # Define root and branch tips
#' pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
#' branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
#' names(branch.tips) <- c("CD8+T", "CD4+T")
#' root <- which.min(pca[, 1])
#'
#' # Construct Diffusion Map
#' dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
#' dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
#'
#' # Markov Chain Construction
#' pb.milo <- markovProbability(
#'     milo = pb.milo,
#'     diffusionmap = dm,
#'     diffusiontime = dif.pse[[paste0("DPT", root)]],
#'     terminal_state = branch.tips,
#'     root_cell = root,
#'     pseudotime_key = "pseudotime"
#' )
#' @return milo or SinglCellExperiment object with pseudotime, probabilities in
#' its colData
#' @include determMultiscaleSpace.R
#' @include minMaxScale.R
#' @include maxMinSampling.R
#' @include differentiationProbabilities.R
#' @include projectProbability.R
#' @import SingleCellExperiment
#' @importFrom rlang abort
#' @importFrom S4Vectors DataFrame metadata metadata<-
#' @importFrom SummarizedExperiment colData<-
#' @export
markovProbability <- function(
    milo, diffusionmap, terminal_state = NULL, root_cell, knn = 30L,
    diffusiontime = NULL, pseudotime_key = "pseudotime",
    scale_components = TRUE, num_waypoints = 500, n_eigs = NULL,
    verbose = TRUE, use_RANN = TRUE) {
    if (is.null(milo[[pseudotime_key]])) {
        if (is.null(diffusiontime)) { # nocov start
            abort(paste(
                "Missing pseudotime data. This data can be either stored in",
                deparse(substitute(milo)), "or provided by 'diffusiontime'"
            )) # nocov end
        } else {
            milo[[pseudotime_key]] <- diffusiontime
        }
    } else {
        diffusiontime <- milo[[pseudotime_key]] # nocov
    }
    # scale data
    multiscale <- .determineMultiscaleSpace(diffusionmap, n_eigs = n_eigs)
    if (scale_components) {
        multiscale <- .minMaxScale(multiscale)
    }
    # sample waypoints to construct markov chain
    waypoints <- .maxMinSampling(
        datas = multiscale, num_waypoints = 500,
        verbose = verbose
    )
    unique_waypoint <- setdiff(unique(c(root_cell, waypoints)), terminal_state)
    waypoints <- c(unique_waypoint, terminal_state)
    # calculate probabilities
    prob_term <- differentiationProbabilities(multiscale[waypoints, ],
        terminal_states = terminal_state, knn = knn, pseudotime = diffusiontime,
        waypoints = waypoints, verbose = verbose, use_RANN = use_RANN
    )
    probabilities <- prob_term[[1]]
    terminal_state <- prob_term[[2]]
    # project probabilities from waypoints to each pseudobulk
    probabilities_proj <- projectProbability(
        diffusionmap, waypoints,
        probabilities,
        verbose = verbose
    )
    # store the result into milo
    milo <- .addColData(probabilities_proj, terminal_state, milo, verbose)
    return(milo)
}

#' add the calculated probability to the colData
#'
#' @param probabilities_proj the probabilities need to be stored
#' @param terminal_state Integer. The index of the terminal state in the Markov
#' chain, passed from markovProbability
#' @param milo the milo object provided by user
#' @param verbose logical, print warnings.
#' @keywords internal
#' @return a Milo object with probabilties and pseudotime in its colData slot
#' @importFrom S4Vectors DataFrame metadata metadata<-
#' @importFrom SummarizedExperiment colData<-
.addColData <- function(probabilities_proj, terminal_state, milo, verbose) {
    new_coldata <- DataFrame(as.matrix(probabilities_proj))
    if (is.null(names(terminal_state))) {
        names(terminal_state) <- paste0(
            "terminal_state",
            seq(length(terminal_state))
        )
    }
    colnames(new_coldata) <- c(names(terminal_state))
    colData(milo) <- cbind(colData(milo), new_coldata)
    metadata(milo) <- c(metadata(milo), list(branch.tips = terminal_state))
    return(milo)
}

#' dandelionR: Single-cell immune repertoire trajectory analysis
#'
#' dandelionR is an R package for performing single-cell immune repertoire
#' trajectory analysis, based on the original python implementation.
#' It provides the necessary functions to interface with scRepertoire and a
#' custom implementation of an absorbing Markov chain for pseudotime
#' inference, inspired by the Palantir Python package.
#'
#' @section Main functions:
#' - \code{\link{setupVdjPseudobulk}}: Preprocess V(D)J Data for Pseudobulk
#' Analysis.
#' - \code{\link{vdjPseudobulk}}: Generate Pseudobulk V(D)J Feature Space.
#' - \code{\link{markovProbability}}: Markov Chain Construction and
#' Probability Calculation.
#' - \code{\link{projectPseudotimeToCell}}: Project Pseudotime and Branch
#' Probabilities to Single Cells.
#'
#' @section Vignettes:
#' See the package vignettes for detailed workflows:
#' \code{vignette('dandelionR')}
#'
#' @section Installation:
#' To install from Bioconductor, use:
#' \preformatted{
#' if (!requireNamespace('BiocManager', quietly = TRUE))
#'     install.packages('BiocManager')
#' BiocManager::install('dandelionR')
#' }
#'
#' @name dandelionR
#' @keywords internal
"_PACKAGE"

#' .maxMinSampling
#'
#' function for max min sampling of waypoints
#'
#' @param datas data matrix along which to sample the waypoints, usually
#'  diffusion components
#' @param num_waypoints number of waypoints to sample
#' @param verbose logical, print progress
#' @keywords internal
#' @return Series reprenting the sampled waypoints
.maxMinSampling <- function(datas, num_waypoints, verbose = TRUE) {
    if (verbose) message("Sampling and flocking waypoints...")
    no.iterations <- as.integer(num_waypoints / ncol(datas))
    waypoints <- c()
    # Sample along each componet
    waypoints <- Reduce(function(waypoints, ind) {
        waypoints <- .waypiontsPerCol(
            waypoints = waypoints, ind = ind,
            datas = datas, no.iterations = no.iterations
        )
        return(waypoints)
    }, colnames(datas), waypoints)
    waypoints <- unique(waypoints)
    return(waypoints)
}


#' find the waypoints according to certain columns of data
#'
#' @param waypoints integer vector used to store waypoints
#' @param ind columns' colnames
#' @param datas scaled diffusionmap
#' @keywords internal
#' @return a numeric vector containing waypoints' index
.waypiontsPerCol <- function(waypoints, ind, datas, no.iterations) {
    N <- nrow(datas)
    vecs <- datas[, ind]
    iter.set <- sample(seq_len(N), 1)
    dists <- matrix(0, nrow = N, ncol = no.iterations)
    dists[, 1] <- abs(vecs - vecs[iter.set])
    iterdists <- list(iter.set = iter.set, dists = dists)
    iterdists <- Reduce(function(iterdists, k) {
        .findNewWaypoints(iterdists, k, vecs = vecs, ind = ind, datas = datas)
    }, seq_len(no.iterations - 1), iterdists)
    waypoints <- c(waypoints, iterdists$iter.set)
    return(waypoints)
}


#' function used in Reduce to find new waypoint in an iteration
#'
#' @param iterdists a list containing both waypoints deteted in
#'  the former iterations and the distance matrix used to find waypoints
#' @param k the iteration number
#' @param vecs a numeric vector used to calculate distance of waypoints to
#'  each points
#' @param ind colnames
#' @keywords internal
#' @return a list containing updated distance matrix and new waypoints
.findNewWaypoints <- function(iterdists, k, vecs, ind, datas) {
    iter.set <- iterdists$iter.set
    dists <- iterdists$dists
    # minium distances
    min_dists <- apply(dists[, seq_len(k), drop = FALSE], 1, min)
    # new waypoint: where the maxium of the minimum distane locate
    new.wp <- which.max(min_dists)
    iter.set <- c(iter.set, new.wp)
    dists[, k + 1] <- abs(vecs - datas[new.wp, ind])
    return(list(iter.set = iter.set, dists = dists))
}

#' .filterCells
#'
#' Helper function that identifies filter_pattern hits in determined column of
#'  sce, and then either removes the offeending cells or masks
#'   the matched values with a uniform value of '(column's name)_missing'
#' @param sce SingleCellExperiment object, adata in python
#' data after combineTCR, contain both vdj and seq
#' @param col_n mode for extraction the V(D)J genes.
#' @param filter_pattern character string,
#'  optional ',|None|No_contig' by default
#' @param remove_missing bool, True by default
#'  - If `TRUE`, will remove cells with contigs matching the filter from
#'   the object.
#'  - If `FALSE`, will mask them with a uniform value dependent on the column
#'   name.
#' @import SingleCellExperiment
#' @importFrom SummarizedExperiment colData<-
#' @keywords internal
#' @importFrom rlang abort
#' @return filtered SingleCellExperiment object according to the parameter.
.filterCells <- function(
    sce, col_n,
    filter_pattern = ",|None|No_contig",
    remove_missing = TRUE) {
    if (ncol(sce) < 1) {
        abort(sprintf(paste(
            "None column remains, please check whether the",
            "filtering option is correct."
        )))
    }
    # find filter pattern hits in our column of interest
    temp <- colData(sce)[col_n]
    temp <- as.data.frame(temp@listData)
    mask <- grep(filter_pattern, temp[, 1])
    if (remove_missing) {
        sce <- sce[, setdiff(seq_len(ncol(sce)), mask)]
    } else {
        # uniformly mask the filter pattern hits
        colData(sce)[mask, col_n] <- sprintf("%s_missing", col_n)
    }
    return(sce)
}

library(rlang)

# Mock data for testing
set.seed(100)
data <- matrix(rnorm(100), ncol = 10)
col_data <- data.frame(
    VDJ = c(
        "None", "TRBV7-9", "TRBV7-9", "None", "TRBV7-9",
        "No_contig", "TRBV7-9", "TRBV7-9", "None", "TRBV7-9"
    )
)
sce <- SingleCellExperiment(assays = list(counts = data), colData = col_data)

# Test for .filterCells
test_that(".filterCells works correctly with remove_missing = TRUE", {
    result <- .filterCells(sce, "VDJ", remove_missing = TRUE)

    expect_true(is(result, "SingleCellExperiment"))
    expect_equal(ncol(result), 6)
    expect_false(any(colData(result)$VDJ %in% c("None", "No_contig")))
})

test_that(".filterCells works correctly with remove_missing = FALSE", {
    result <- .filterCells(sce, "VDJ", remove_missing = FALSE)

    expect_true(is(result, "SingleCellExperiment"))
    expect_equal(ncol(result), 10)
    expect_true(all(colData(result)$VDJ[grep(
        "None|No_contig",
        colData(result)$VDJ
    )] == "VDJ_missing"))
})

# Additional tests for edge cases
test_that(".filterCells handles edge cases", {
    # Test with empty SingleCellExperiment
    empty_sce <- SingleCellExperiment(assays = list(counts = matrix(
        nrow = 0,
        ncol = 0
    )))
    expect_error(
        .filterCells(empty_sce, "VDJ"),
        sprintf(paste(
            "None column remains, please check whether the",
            "filtering option is correct."
        ))
    )

    # Test with no matching filter pattern
    no_match_sce <- SingleCellExperiment(
        assays = list(counts = data),
        colData = data.frame(VDJ = rep("TRBV7-9", 10))
    )
    result_no_match <- .filterCells(no_match_sce, "VDJ", remove_missing = TRUE)
    expect_equal(ncol(result_no_match), 10)
})

## ----echo=FALSE, results="hide", message=FALSE--------------------------------
knitr::opts_chunk$set(error = FALSE, message = FALSE, warning = FALSE)
library(BiocStyle)

## ----message=FALSE, warning=FALSE---------------------------------------------
library(dandelionR)
library(scRepertoire)
library(scater)

## ----warning = FALSE----------------------------------------------------------
data(sce_vdj)

## -----------------------------------------------------------------------------
set.seed(100)

## ----warning = FALSE----------------------------------------------------------
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c(
        "Single pair", "Extra pair",
        "Extra pair-exception", "Orphan VDJ",
        "Orphan VDJ-exception"
    )
)

## ----warning = FALSE----------------------------------------------------------
plotUMAP(sce_vdj, color_by = "anno_lvl_2_final_clean")

## ----warning = FALSE----------------------------------------------------------
library(miloR)
traj_milo <- Milo(sce_vdj)
milo_object <- buildGraph(traj_milo, k = 50, d = 20, reduced.dim = "X_scvi")
milo_object <- makeNhoods(milo_object, reduced_dims = "X_scvi", d = 20)

## ----warning = FALSE----------------------------------------------------------
milo_object <- miloUmap(milo_object)

## -----------------------------------------------------------------------------
plotUMAP(milo_object,
    color_by = "anno_lvl_2_final_clean",
    dimred = "UMAP_knngraph"
)

## -----------------------------------------------------------------------------
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")

pb.milo <- runPCA(pb.milo, assay.type = "Feature_space")

## -----------------------------------------------------------------------------
plotPCA(pb.milo, color_by = "anno_lvl_2_final_clean")

## -----------------------------------------------------------------------------
library(SingleCellExperiment)

# extract the PCA matrix
pca <- t(as.matrix(reducedDim(pb.milo, type = "PCA")))
# define the CD8 terminal cell as the top-most cell and CD4 terminal cell as
# the bottom-most cell
branch.tips <- c(which.max(pca[2, ]), which.min(pca[2, ]))
names(branch.tips) <- c("CD8+T", "CD4+T")
# define the start of our trajectory as the right-most cell
root <- which.max(pca[1, ])

## ----warning = FALSE----------------------------------------------------------
library(destiny)
# Run diffusion map on the PCA
feature_space <- t(assay(pb.milo, "Feature_space"))
dm <- DiffusionMap(as.matrix(feature_space), n_pcs = 50, n_eigs = 10)

## -----------------------------------------------------------------------------
dif.pse <- DPT(dm, tips = c(root, branch.tips), w_width = 0.1)

## ----message=FALSE------------------------------------------------------------
# the root is automatically called DPT + index of the root cell
DPTroot <- paste0("DPT", root)
# store pseudotime in milo object
pb.milo$pseudotime <- dif.pse[[DPTroot]]
# set the colours for pseudotime
pal <- colorRampPalette(rev((RColorBrewer::brewer.pal(9, "RdYlBu"))))(255)
plotPCA(pb.milo, color_by = "pseudotime") +
    scale_colour_gradientn(colours = pal)

## -----------------------------------------------------------------------------
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    terminal_state = branch.tips,
    root_cell = root,
    pseudotime_key = "pseudotime"
)

## ----message=FALSE------------------------------------------------------------
plotPCA(pb.milo, color_by = "CD8+T") + scale_color_gradientn(colors = pal)
plotPCA(pb.milo, color_by = "CD4+T") + scale_color_gradientn(colors = pal)

## -----------------------------------------------------------------------------
cdata <- projectPseudotimeToCell(milo_object, pb.milo, value_key = c("pseudotime", "CD8+T", "CD4+T"))

## ----message=FALSE------------------------------------------------------------
plotUMAP(cdata, color_by = "anno_lvl_2_final_clean", dimred = "UMAP_knngraph")
plotUMAP(cdata, color_by = "pseudotime", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD4+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD8+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)

## ----warning = FALSE----------------------------------------------------------
sessionInfo()

#' Project Probabilities from Markov Chain to Pseudobulks
#'
#' This function projects probabilities calculated from a Markov chain onto
#'  each pseudobulk based on a diffusion distance matrix.
#'
#' @param diffusionmap diffusion map, used to reconstruct
#'  diffustion distance matrix
#' @param waypoints Integer vector. Indices of the waypoints used in
#'  the Markov chain.
#' @param probabilities Numeric vector. Probabilities associated with
#'  the waypoints, calculated from the Markov chain.
#' @param t Numeric. The diffusion time to be used in the projection.
#' @param verbose Boolean, whether to print messages/warnings.
#' @importFrom destiny eigenvectors eigenvalues
#' @importFrom stats sd
#' @return each pseudobulk's probabilites
projectProbability <- function(
    diffusionmap, waypoints, probabilities, t = 1,
    verbose = TRUE) {
    if (verbose) {
        message("Project probabilites from waypoints to each pseudobulk...")
    }
    # Extract eigenvalues and eigenvectors from the DiffusionMap
    eigenvalues <- eigenvalues(diffusionmap) # vector of eigenvalues
    # matrix of eigenvectors (each column is an eigenvector)
    eigenvectors <- eigenvectors(diffusionmap)
    # Set diffusion time `t` and the number of components `K` to use
    t <- 1 # diffusion time
    K <- min(length(eigenvalues), ncol(eigenvectors)) # use available components
    # Precompute squared eigenvalues scaled by diffusion time
    lambda_t <- (eigenvalues[seq_len(K)])^(2 * t)
    # Initialize an empty matrix for the diffusion distances
    n <- nrow(eigenvectors)
    index_pairs <- which(upper.tri(matrix(1, n, n)), arr.ind = TRUE)
    # Calculate the pairwise diffusion distance
    distances <- apply(index_pairs, 1, .calDif,
        lambda_t = lambda_t,
        eigenvector = eigenvectors, K = K
    )
    D_diffusion <- matrix(0, n, n)
    D_diffusion[upper.tri(D_diffusion)] <- distances
    D_diffusion <- D_diffusion + t(D_diffusion)
    # `D_diffusion` is now the diffusion distance matrix
    Dif <- D_diffusion[, waypoints]
    D_ravel <- as.vector(Dif)
    sdv <- sd(D_ravel) * 1.06 * (length(D_ravel)^(-1 / 5))
    W <- exp(-0.5 * ((Dif / sdv)^2))
    W <- W / apply(W, 1, sum)
    prob <- W %*% probabilities
    if (verbose) message("Complete.")
    return(prob)
}


#' function help to calculate the diffusion distance
#'
#' @param idx integer the index of the calculated value
#' @param eigenvector numeric vector, the eigenvector from diffusion map
#' @param lambda_t eigenvalues to the power of t(diffusion time)
#' @param K The number of the eigenvectors to be used in calculation
#' @keywords internal
#' @return updated diffusion distance matrix after one iteration
.calDif <- function(idx, eigenvector, lambda_t, K) {
    i <- idx[1]
    j <- idx[2]
    diff <- eigenvector[i, seq_len(K)] - eigenvector[j, seq_len(K)]
    sqrt(sum(lambda_t * diff^2))
}

#' .determineMultiscaleSpace
#'
#' @param diffusionmap DiffusionMap object
#' @param n_eigs integer, default is NULL. Number of eigen vectors to use.
#' - If is not specified, the number of eigen vectors will be determined using
#'  the eigen gap.
#' @keywords internal
#' @importFrom destiny eigenvectors eigenvalues
#' @returns dataframe
.determineMultiscaleSpace <- function(diffusionmap, n_eigs = NULL) {
    .classCheck(diffusionmap, "DiffusionMap")
    eigenvect <- eigenvectors(diffusionmap)
    eigenval <- eigenvalues(diffusionmap)
    # determine n_eigs
    if (is.null(n_eigs)) {
        val_gaps <- eigenval[2:length(eigenval) - 1] -
            eigenval[2:length(eigenval)]
        n_eigs <- order(val_gaps)[length(val_gaps)]
        if (n_eigs < 3) {
            n_eigs <- order(val_gaps)[length(val_gaps) - 1]
        }
    }
    # Scale the data
    use_eigs <- seq(1, n_eigs)
    eigenvect <- eigenvect[, use_eigs]
    eigenval <- eigenval[use_eigs]
    multis <- apply(eigenvect, 1, `*`, (eigenval / (1 - eigenval)))
    return(data.frame(t(multis)))
}

#' Example Dataset for V(D)J Analysis
#'
#' The `sce_vdj` object is a down-sampled demo dataset derived from
#' Suo et al., 2024, *Nature Biotechnology*. \cr
#' This dataset is used in vignettes to demonstrate workflows for V(D)J
#' analysis. \cr For details, see the original
#' publication at \url{https://www.nature.com/articles/s41587-023-01734-7}.
#'
#' @docType data
#' @usage data(sce_vdj)
#' @format A `SingleCellExperiment` object with the following slots:
#' \describe{
#'   \item{\code{colData}}{
#'     A `DataFrame` containing metadata about each sample, corresponding
#'      to `obs` in AnnData (Python).
#'     The following columns are relevant for vignette usage:
#'     \describe{
#'       \item{\code{productive_(mode)_VDJ}, \code{productive_(mode)_VJ}}{
#'         Factors indicating whether the heavy or light chain is
#'          productive. \code{mode} refers to the
#'         extraction mode for V(D)J genes and can be one of:
#'         \itemize{
#'           \item{\code{'abT'}}: TCR alpha-beta
#'           \item{\code{'gdT'}}: TCR gamma-delta
#'           \item{\code{'B'}}: BCR
#'         }
#'       }
#'       \item{\code{Gene segment fields}}{
#'         Gene segment annotations with column names in the format
#'          \code{(v/d/j)_call_(mode)_(VDJ/VJ)}.
#'         Examples include:
#'         \itemize{
#'           \item{\code{v_call_abT_VDJ}}: V gene for TCR alpha-beta
#'            VDJ recombination
#'           \item{\code{d_call_abT_VJ}}: D gene for TCR alpha-beta
#'            VJ recombination
#'         }
#'       }
#'       \item{\code{chain_status}}{
#'         A factor describing the receptor chain's status.
#'       }
#'       \item{\code{anno_lvl_2_final_clean}}{
#'         Cell type annotations.
#'       }
#'     }
#'   }
#'   \item{\code{int_colData}}{
#'     A `DataFrame` containing additional assay metadata important for further
#'      analysis. Includes:
#'     \itemize{
#'       \item{\code{X_scvi}}: A dimensionality reduction matrix from the
#'        scVI model.
#'       \item{\code{UMAP}}: A UMAP reduction matrix.
#'     }
#'   }
#' }
#'
#' @source Suo et al., 2024, *Nature Biotechnology*.\cr
#'  \url{https://www.nature.com/articles/s41587-023-01734-7}.
#' @examples
#' data(sce_vdj)
"sce_vdj"

#' Example SCE Dataset that does not contain V(D)J information
#'
#' The `demo_sce` object is a down-sampled demo dataset derived from
#' Suo et al., 2024, *Nature Biotechnology*.\cr
#' This dataset is used in vignettes to demonstrate workflows for V(D)J
#' analysis.\cr For details, see the original
#' publication at \url{https://www.nature.com/articles/s41587-023-01734-7}.
#' The original Lymphoid cells data in h5ad format is available at
#' \url{https://developmental.cellatlas.io/fetal-immune}.
#'
#' @docType data
#' @usage data(demo_sce)
#' @format A `SingleCellExperiment` object with the following slots:
#' \describe{
#'   \item{\code{colData}}{
#'     A minimall `DataFrame` containing metadata about each sample,
#'      corresponding to `obs` in AnnData (Python).
#'     The following columns are relevant for vignette usage:
#'     \describe{
#'       \item{\code{anno_lvl_2_final_clean}}{
#'         Cell type annotations.
#'       }
#'     }
#'   }
#'   \item{\code{int_colData}}{
#'     A `DataFrame` containing additional assay metadata important for further
#'     analysis. Includes:
#'     \itemize{
#'       \item{\code{X_scvi}}: A dimensionality reduction matrix from the scVI
#'        model.
#'       \item{\code{UMAP}}: A UMAP reduction matrix.
#'     }
#'   }
#' }
#'
#' @source Suo et al., 2024, *Nature Biotechnology*. \cr
#'  \url{https://www.nature.com/articles/s41587-023-01734-7}.
#' @examples
#' data(demo_sce)
"demo_sce"

#' Example AIRR Dataset for V(D)J Analysis
#'
#' The `demo_airr` object is a list of AIRR data frames from a down-sampled
#' demo dataset derived from Suo et al., 2024, *Nature Biotechnology*.\cr
#' This dataset is used in vignettes to demonstrate workflows for
#' V(D)J analysis.\cr
#' For details, see the original publication at
#' \url{https://www.nature.com/articles/s41587-023-01734-7}.\cr
#' The original files are available at
#' \url{https://github.com/zktuong/dandelion-demo-files}.
#'
#' @docType data
#' @usage data(demo_airr)
#' @format A `SingleCellExperiment` object with the following slots:
#' \describe{
#'   \item{\code{list}}{
#'     List of `DataFrames` containing the standardised AIRR data for
#'      each sample. \cr
#'     For information of AIRR rearrangements, see the AIRR Community
#'      standards at \url{https://docs.airr-community.org/}.
#'   }
#' }
#'
#' @source Suo et al., 2024, *Nature Biotechnology*. \cr
#' \url{https://www.nature.com/articles/s41587-023-01734-7}.
#' @examples
#' data(demo_airr)
"demo_airr"

#' Split the V(D)J genes from `CTgene` column and store them separately.
#'
#' @param sce SingleCellExperiment object after conducting
#'  scRepertoire::combineTCR()
#' @keywords internal
#' @return list contain vector of VJ & VDJ genes from each cell
#' @importFrom SummarizedExperiment colData<-
splitCTgene <- function(sce) {
    CTgene <- colData(sce)[, "CTgene"]
    # split with '_'
    CTgene <- lapply(CTgene, strsplit, split = "_")
    # split with '.'
    CTgene <- lapply(CTgene, function(x) {
        lapply(x, strsplit, split = "[.]")
    })
    CTgene <- .collapse_nested_list(CTgene)
    # this is a list containing `ncol()` sublists,
    # where each sublist contains two character vectors: the first represent
    # TRA the second represent TRB
    CTgene <- lapply(CTgene, formatVdj)
    return(lapply(CTgene, unlist))
}

#' Change the format of splitCTgene output.
#'
#' @param gene_list list containing the output from splitCTgene.
#' @keywords internal
#' @return list contain vector of VJ + VDJ information of the cell input
formatVdj <- function(gene_list) {
    if (all(is.na(gene_list))) {
        vj <- rep("None", 2)
        vdj <- rep("None", 3)
    } else {
        vj <- chainAssign(gene_list[[1]], num = 2, min_len = 2, max_len = 3)
        vdj <- chainAssign(gene_list[[2]], num = 3, min_len = 3, max_len = 4)
    }
    return(append(vj, vdj))
}


#' Assign the V(D)J gene to the right chain.
#'
#' @param vec vector of V(D)J genes to assign to the right chain.
#' @param num number of genes to return. should be 2(vj) or 3(vdj)
#' @param min_len minimum length of the vector to account for missing constant gene.
#' @param max_len maximum length of the vector to account for multiple chains.
#' @keywords internal
#' @return list contain vector of VJ + VDJ of the cell input
#' @importFrom rlang abort
chainAssign <- function(vec, num, min_len, max_len) {
    vec_len <- length(vec)
    if (vec_len >= min_len && vec_len <= max_len) {
        chains <- vec[seq_len(num)]
    } else if (all(vec == "NA")) {
        # nocov start
        chains <- rep("None", num)
    } else {
        abort(paste(
            "Multiple chains detected. Please set `removeMulti = TRUE`",
            "when using `combineTCR()`."
        )) # nocov end
    }
    return(chains)
}

#' Collapse a nested list
#'
#' @param input_list input nested list.
#' @keywords internal
#' @return collapsed list
.collapse_nested_list <- function(input_list) {
    all_are_lists <- all(vapply(input_list, function(sublist) {
        all(vapply(sublist, is.list, FUN.VALUE = logical(1))) & is.list(sublist)
    }, FUN.VALUE = logical(1)))
    # If all elements are lists, unlist one level
    if (all_are_lists) {
        return(.collapse_nested_list(unlist(input_list, recursive = FALSE)))
    }
    return(input_list) # nocov
}

#' Determine terminal states using Markov chain if end states are not provided.
#'
#' @param Transmat Transition matrix
#' @param wp_data Multi scale data of the waypoints
#' @param pseudotime numeric vector, pseudotime of each pseudobulk
#' @param waypoints integer vector, waypoint selected to construct markov chain.
#' @param verbose Boolean, whether to print messages/warnings.
#' @keywords internal
#' @importFrom igraph graph_from_adjacency_matrix components
#' @importFrom purrr map
#' @importFrom stats median qnorm
#' @importFrom spam nearest.dist
#' @return terminal_state
.terminalStateFromMarkovChain <- function(
    Transmat, wp_data, pseudotime,
    waypoints, verbose) {
    if (verbose) {
        message(c(
            "No terminal state provided, identification of",
            " terminal states...."
        ))
    }
    # Identify terminal states dm_boundaries
    n <- min(dim(Transmat))
    ei <- eigen(t(Transmat))
    idx <- order(Re(ei$values), decreasing = TRUE)[seq_len(10)]
    vals <- Re(ei$values[idx])
    vecs <- ei$vectors[, idx]
    dm_boudaries <- unique(
        apply(Transmat, 2, which.max),
        apply(Transmat, 2, which.min)
    )
    ranks <- abs(Re(vecs[, which.max(Re(vals)), drop = FALSE]))
    # cutoff and intersection with the boundary cells
    cutoff <- qnorm(0.9999, mean = median(ranks), sd = median(abs(ranks -
        median(ranks))))
    # connect components of cells beyond cutoff
    cells <- which(ranks > cutoff)
    # Find connected components
    graph <- graph_from_adjacency_matrix(Transmat[cells, cells],
        weighted = TRUE,
        mode = "directed"
    )
    components_g <- components(graph)
    cells <- unlist(map(.x = seq_len(components_g$no), .f = ~ {
        nodes_in_component <- which(components_g$membership == .x)
        id <- which.max(pseudotime[nodes_in_component])
        nodes_in_component[id]
    }))
    # Nearest diffusion map boundaries
    terminal_states <- c()
    terminal_states <- Reduce(function(term, i) {
        terminal_states <- .determTerminal(
            terminal_states = term, i = i,
            dm_boudaries = dm_boudaries, wp_data = wp_data
        )
        return(terminal_states)
    }, cells, init = terminal_states)
    unique(waypoints[terminal_states])
}

#' .determTerminal
#'
#' function in Reduce to provide waypoints
#' @param terminal_states integer vector to store the generated waypoint index
#' @param i iteration index
#' @param dm_boudaries index of the maxium or minium value of
#'  transition matrix per row
#' @param wp_data Multi scale data of the waypoints
#' @keywords internal
#' @return integer vector store the index of waypoints serve as terminal state
.determTerminal <- function(terminal_states, i, dm_boudaries, wp_data) {
    dists <- nearest.dist(wp_data[dm_boudaries, ], wp_data[i, , drop = FALSE])
    terminal_states <- c(
        terminal_states,
        dm_boudaries[which.max(dists@entries)]
    )
    return(terminal_states)
}

---
title: "Single-cell immune repertoire trajectory analysis with dandelionR and slingshot"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
    number_sections: true
knitr:
  opts_chunk:
    dev: 'png'
    fig.align: 'left'
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{Single-cell immune repertoire trajectory analysis with dandelionR and slingshot}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r, echo=FALSE, results="hide", message=FALSE}
knitr::opts_chunk$set(error = FALSE, message = FALSE, warning = FALSE)
library(BiocStyle)
```

# Foreword

In this vignette, we will demonstrate how to perform TCR trajectory analysis
using the `dandelionR` package in conjunction with `slingshot`.

# Installing slinshot
```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
if (!requireNamespace("slinghot", quietly = TRUE)) {
    BiocManager::install("slingshot")
}
```
## Load the required libraries and data

```{r, message=FALSE, warning=FALSE}
library(dandelionR)
library(scRepertoire)
library(scater)

data(sce_vdj)
```

We will also set the seed so that the plots and results are consistent.
```{r}
set.seed(123)
```

## Setup the data as per the other vignettes
We will use the full `SingleCellExperiment` object `sce_vdj` that contains enough cells to demonstrate the trajectory analysis with `slingshot`.
```{r}
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c(
        "Single pair", "Extra pair",
        "Extra pair-exception", "Orphan VDJ",
        "Orphan VDJ-exception"
    )
)

plotUMAP(sce_vdj, color_by = "anno_lvl_2_final_clean")
```

## Milo object and neighbourhood graph construction
We will use miloR to create the pseudobulks based on the gene expression data. 
The goal is to construct a neighbourhood graph with many neighbors with which 
we can sample the representative neighbours to form the objects.

```{r, warning = FALSE}
library(miloR)
milo_object <- Milo(sce_vdj)
milo_object <- buildGraph(milo_object, k = 30, d = 20, reduced.dim = "X_scvi")
milo_object <- makeNhoods(milo_object,
    reduced_dims = "X_scvi", d = 20,
    prop = 0.3
)
```
## Construct UMAP on milo neighbor graph

We can visualise this milo object using UMAP.

```{r, warning = FALSE}
milo_object <- miloUmap(milo_object, n_neighbors = 30)
```

```{r}
plotUMAP(milo_object,
    color_by = "anno_lvl_2_final_clean",
    dimred = "UMAP_knngraph"
)
```

# Construct pseudobulked VDJ feature space

Next, we will construct the pseudobulked VDJ feature space using the 
neighbourhood graph constructed above. We will also run PCA on the 
pseudobulked VDJ feature space.
```{r}
pb.milo <- vdjPseudobulk(milo_object,
    mode_option = "abT",
    col_to_take = "anno_lvl_2_final_clean"
)
```

Inspect the newly created `pb.milo` object.
```{r}
pb.milo
```

We can compute and visualise the PCA of the pseudobulked VDJ feature space.
```{r}
pb.milo <- runPCA(pb.milo, assay.type = "Feature_space", ncomponents = 20)
plotPCA(pb.milo, color_by = "anno_lvl_2_final_clean")
```

## TCR trajectory inference using Slingshot
In the original dandelion Python package, trajectory inference is performed using the palantir package.
Here, we instead use the Slingshot package.
```{r}
library(slingshot)
```

### input
Slingshot requires a matrix representing cells in a reduced-dimensional space and a vector of cluster labels.
Here, we use PCA for dimensionality reduction and the column anno_lvl_2_final_clean from colData as the cluster labels.
```{r}
table(colData(pb.milo)[["anno_lvl_2_final_clean"]])
```

### run slingshot
```{r}
pb.milo <- slingshot(pb.milo, clusterLabels = colData(pb.milo)[["anno_lvl_2_final_clean"]], reducedDim = "PCA", start.clus = "faDP(P)_T", end.clus = c("faCD4+T", "faCD8+T"))
```

# Visualization
pseudotime of each lineage, if the pseudobulk is with value NA, it will not appear on the phage.

```{r}
library(fields)
# make a color palette from blue to red
colors <- colorRampPalette(rev(c("#d7191c", "#fdae61", "#ffffbf", "#abd9e9", "#2c7bb6")))(50)
plot(reducedDims(pb.milo)$PCA, col = colors[cut(pb.milo$slingPseudotime_1, breaks = 50)], pch = 16, asp = 1)
lines(SlingshotDataSet(pb.milo), lwd = 2, col = "black")
image.plot(
    legend.only = TRUE,
    zlim = range(pb.milo$slingPseudotime_1, na.rm = TRUE),
    col = colors,
    legend.lab = "Pseudotime"
)
```
```{r}
plot(reducedDims(pb.milo)$PCA, col = colors[cut(pb.milo$slingPseudotime_2, breaks = 50)], pch = 16, asp = 1)
lines(SlingshotDataSet(pb.milo), lwd = 2, col = "black")
image.plot(
    legend.only = TRUE,
    zlim = range(pb.milo$slingPseudotime_2, na.rm = TRUE),
    col = colors,
    legend.lab = "Pseudotime"
)
```

# Transfer
The next step is to project the pseudotime 
information from the pseudobulks back to each cell in the dataset. If the cell 
do not belong to any of the pseudobulk, it will be removed. If a cell belongs 
to multiple pseudobulk samples, its value should be calculated as a weighted 
average of the corresponding values from each pseudobulk, where each weight 
is inverse of the size of the pseudobulk.
Pseudobulks with NA values are excluded during the projection. If all pseudobulks associated with a cell have NA values, the projected value for that cell will also be NA.
## Project pseudobulk data to each cell
```{r}
cdata <- projectPseudotimeToCell(milo_object, pb.milo, value_key = c("slingPseudotime_1", "slingPseudotime_2"))
```

## Visualise the trajectory data on a per cell basis
The cell with NA value will in grey.
```{r, message=FALSE}
pal <- colorRampPalette(rev((RColorBrewer::brewer.pal(9, "RdYlBu"))))(255)
plotUMAP(cdata, color_by = "anno_lvl_2_final_clean", dimred = "UMAP_knngraph")
plotUMAP(cdata, color_by = "slingPseudotime_1", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "slingPseudotime_2", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
```

And that's it! We have successfully inferred the trajectory of the T-cells in 
this dataset with `slingshot`!

# Session info

```{r, warning = FALSE}
sessionInfo()
```

---
title: "Single-cell immune repertoire trajectory analysis with dandelionR"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
    number_sections: true
knitr:
  opts_chunk:
    dev: 'png'
    fig.align: 'left'
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{Single-cell immune repertoire trajectory analysis with dandelionR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r, echo=FALSE, results="hide", message=FALSE}
knitr::opts_chunk$set(error = FALSE, message = FALSE, warning = FALSE)
library(BiocStyle)
```

# Foreword

Welcome to `dandelionR`!

`dandelionR` is an R package for performing single-cell immune repertoire
trajectory analysis,  based on the original python implementation in 
[dandelion](https://www.github.com/zktuong/dandelion). 

It provides all the necessary tools to interface with
[scRepertoire](https://github.com/ncborcherding/scRepertoire) 
and a custom implementation of absorbing markov chain for pseudotime inference, 
inspired based on the [palantir](https://github.com/dpeerlab/Palantir) python 
package.

This is a work in progress, so please feel free to open an issue if you 
encounter any problems or have any suggestions for improvement.

# Installation

You can install `dandelionR` with:

## Bioconductor
```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
# The following initializes usage of Bioc devel
BiocManager::install(version = "devel")

BiocManager::install("dandelionR")
```

## Development version (GitHub)
```{r, eval = FALSE}
if (!requireNamespace("devtools", quietly = TRUE)) {
    install.packages("devtools")
}
devtools::install_github("tuonglab/dandelionR", dependencies = TRUE)
```

In a standard analysis workflow in R, users probably choose to read in their 
VDJ data with [scRepertoire](https://github.com/ncborcherding/scRepertoire). 

In this vignette, we will demonstrate how to perform TCR trajectory analysis 
starting from 'raw' data i.e. just a standard single-cell gene expression data 
(stored in `SingleCellExperiment`) and VDJ data (in AIRR format).

Install `scater` and `scRepertoire` if you haven't already.
```{r, eval = FALSE}
# only for the tutorial
if (!requireNamespace("scater", quietly = TRUE)) {
    BiocManager::install("scater")
}
if (!requireNamespace("scRepertoire", quietly = TRUE)) {
    BiocManager::install("scRepertoire")
}
# or
devtools::install_github("ncborcherding/scRepertoire")
```

# Usage

## Load the required libraries

```{r, message=FALSE, warning=FALSE}
library(dandelionR)
library(scRepertoire)
library(scater)
```

## Load the demo data
Due to size limitations of the package, we have provided a very trimmed down 
version of the demo data to ~2000 cells. The full dataset can be found here 
accordingly: 

GEX (Lymphoid Cells) - https://developmental.cellatlas.io/fetal-immune 

VDJ - https://github.com/zktuong/dandelion-demo-files/ 

The VDJ data is in the dandelion_manuscript/data/dandelion-remap folder.

```{r}
data(demo_sce)
data(demo_airr)
```

Check out the other vignette for an example dataset that starts from the 
original `dandelion` output associated with the original 
[manuscript](https://www.nature.com/articles/s41587-023-01734-7).

```{r}
vignette("vignette_reproduce_original")
```

We will also set the seed so that the plots and results are consistent.
```{r}
set.seed(123)
```

# Use `scRepertoire` to load the VDJ data
For the trajectory analysis work here, we are focusing on the main productive 
TCR chains. Therefore we will flag `filterMulti = TRUE`, which will keep the 
selection of the 2 corresponding chains with the highest expression for a 
single barcode. For more details, refer to `scRepertoire`'s 
[docs](https://www.borch.dev/uploads/screpertoire/reference/combinetcr).

```{r}
contig.list <- loadContigs(input = demo_airr, format = "AIRR")

# Format to `scRepertoire`'s requirements and some light filtering
combined.TCR <- combineTCR(contig.list,
    removeNA = TRUE,
    removeMulti = FALSE,
    filterMulti = TRUE
)
```

## Merging VDJ data with gene expression data
Next we will combine the gene expression data with the VDJ data to create a 
`SingleCellExperiment` object.
```{r}
sce <- combineExpression(combined.TCR, demo_sce)
```

# Initiate `dandelionR` workflow
Here, the data is ready to be used for the pseudobulk and trajectory analysis 
workflow in `dandelionR`.

Because this is a alpha-beta TCR data, we will set the `mode_option` to "abT". 
This will append `abT` to the relevant columns holding the VDJ gene 
information. If you are going to try other types of VDJ data e.g. BCR, you 
should set `mode_option` to "B" instead. And this argument should be 
consistently set with the `vdjPseudobulk` function later.

Since the TCR data is already filtered for productive chains in `combineTCR`, 
we will set `already.productive = TRUE` and can keep `allowed_chain_status` 
as `NULL`.

We will also subset the data to only include the main T-cell types: CD8+T, 
CD4+T, ABT(ENTRY), DP(P)_T, DP(Q)_T.
```{r}
sce <- setupVdjPseudobulk(sce,
    mode_option = "abT",
    already.productive = TRUE,
    subsetby = "anno_lvl_2_final_clean",
    groups = c("CD8+T", "CD4+T", "ABT(ENTRY)", "DP(P)_T", "DP(Q)_T")
)
```

The main output of this function is a `SingleCellExperiment` object with the 
relevant VDJ information appended to the `colData`, particularly the columns 
with the `_main` suffix e.g. `v_call_abT_VJ_main`, `j_call_abT_VJ_main` etc.
```{r}
head(colData(sce))
```

Visualise the UMAP of the filtered data.
```{r}
plotUMAP(sce, color_by = "anno_lvl_2_final_clean")
```


## Milo object and neighbourhood graph construction
We will use miloR to create the pseudobulks based on the gene expression data. 
The goal is to construct a neighbourhood graph with many neighbors with which 
we can sample the representative neighbours to form the objects.

```{r, warning = FALSE}
library(miloR)
milo_object <- Milo(sce)
milo_object <- buildGraph(milo_object, k = 30, d = 20, reduced.dim = "X_scvi")
milo_object <- makeNhoods(milo_object,
    reduced_dims = "X_scvi", d = 20,
    prop = 0.3
)
```
## Construct UMAP on milo neighbor graph

We can visualise this milo object using UMAP.

```{r, warning = FALSE}
milo_object <- miloUmap(milo_object, n_neighbors = 30)
```

```{r}
plotUMAP(milo_object,
    color_by = "anno_lvl_2_final_clean",
    dimred = "UMAP_knngraph"
)
```

# Construct pseudobulked VDJ feature space

Next, we will construct the pseudobulked VDJ feature space using the 
neighbourhood graph constructed above. We will also run PCA on the 
pseudobulked VDJ feature space.
```{r}
pb.milo <- vdjPseudobulk(milo_object,
    mode_option = "abT",
    col_to_take = "anno_lvl_2_final_clean"
)
```

Inspect the newly created `pb.milo` object.
```{r}
pb.milo
```

We can compute and visualise the PCA of the pseudobulked VDJ feature space.
```{r}
pb.milo <- runPCA(pb.milo, assay.type = "Feature_space", ncomponents = 20)
plotPCA(pb.milo, color_by = "anno_lvl_2_final_clean")
```

## TCR trajectory inference using Absorbing Markov Chain

In the original `dandelion` python package, the trajectory inference is done 
using the `palantir` package. Here, we implement the absorbing markov chain 
approach in dandelionR to infer the trajectory, leveraging on `destiny` for 
diffusion map computation.

### Define root and branch tips
```{r}
# extract the PCA matrix
pca <- t(as.matrix(reducedDim(pb.milo, type = "PCA")))
# define the CD8 terminal cell as the top-most cell and CD4 terminal cell as
# the bottom-most cell
branch.tips <- c(which.max(pca[2, ]), which.min(pca[2, ]))
names(branch.tips) <- c("CD8+T", "CD4+T")
# define the start of our trajectory as the right-most cell
root <- which.max(pca[1, ])
```

### Construct diffusion map
```{r, warning = FALSE}
library(destiny)
# Run diffusion map on the PCA
feature_space <- t(assay(pb.milo, "Feature_space"))
dm <- DiffusionMap(as.matrix(feature_space), n_pcs = 50, n_eigs = 10)
```

### Compute diffusion pseudotime on diffusion map
```{r}
dif.pse <- DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
```

```{r, message=FALSE}
# the root is automatically called DPT + index of the root cell
DPTroot <- paste0("DPT", root)
# store pseudotime in milo object
pb.milo$pseudotime <- dif.pse[[DPTroot]]
# set the colours for pseudotime
pal <- colorRampPalette(rev((RColorBrewer::brewer.pal(9, "RdYlBu"))))(255)
plotPCA(pb.milo, color_by = "pseudotime") +
    scale_colour_gradientn(colours = pal)
```

# Markov chain construction on the pseudobulk VDJ feature space
This step will compute the Markov chain probabilities on the pseudobulk VDJ 
feature space. It will return the branch probabilities in the `colData` and 
the column name corresponds to the branch tips defined earlier.
```{r}
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    terminal_state = branch.tips,
    root_cell = root,
    pseudotime_key = "pseudotime",
    knn = 30
)
```

Inspect the `pb.milo` object to see the newly added columns.
```{r}
head(colData(pb.milo))
```

# Visualising branch probabilities

With the Markov chain probabilities computed, we can visualise the branch 
probabilities towards CD4+ or CD8+ T-cell fate on the PCA plot.
```{r, message=FALSE}
plotPCA(pb.milo, color_by = "CD8+T") + scale_color_gradientn(colors = pal)
plotPCA(pb.milo, color_by = "CD4+T") + scale_color_gradientn(colors = pal)
```

# Transfer

The next step is to project the pseudotime and the branch probability 
information from the pseudobulks back to each cell in the dataset. If the cell 
do not belong to any of the pseudobulk, it will be removed. If a cell belongs 
to multiple pseudobulk samples, its value should be calculated as a weighted 
average of the corresponding values from each pseudobulk, where each weight 
is inverse of the size of the pseudobulk.

## Project pseudobulk data to each cell
```{r}
cdata <- projectPseudotimeToCell(milo_object, pb.milo, value_key = c("pseudotime", "CD8+T", "CD4+T"))
```

## Visualise the trajectory data on a per cell basis
```{r, message=FALSE}
plotUMAP(cdata, color_by = "anno_lvl_2_final_clean", dimred = "UMAP_knngraph")
plotUMAP(cdata, color_by = "pseudotime", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD4+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD8+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
```

And that's it! We have successfully inferred the trajectory of the T-cells in 
this dataset!

# Session info

```{r, warning = FALSE}
sessionInfo()
```

---
title: "Reproducing the original dandelion method/paper"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
    number_sections: true
knitr:
  opts_chunk:
    dev: 'png'
    fig.align: 'left'
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{Reproducing the original dandelion method/paper}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE, results="hide", message=FALSE}
knitr::opts_chunk$set(error = FALSE, message = FALSE, warning = FALSE)
library(BiocStyle)
```

In this vignette, we will demonstrate how to perform TCR trajectory analysis 
starting from data that has already been processed by `dandelion` in python. 
This is to demonstrate that the original method/results in the `dandelion` 
paper can be reproduced.

## Load the required libraries

We will also load `scRepertoire` and `scater` for the analysis.
```{r, message=FALSE, warning=FALSE}
library(dandelionR)
library(scRepertoire)
library(scater)
```

## Load data
First, we will load the demo data. This is a down-sampled dataset from
[Suo et al 2024](https://www.nature.com/articles/s41587-023-01734-7).

It contains 10,000 cells with the TCR information and the dimensionality 
reduced data (scVI) that we need for this tutorial. The gene expression matrix 
is not required for this tutorial so it is not included in the demo data. We 
will show in a separate tutorial how to start with data from `scRepertoire`.
```{r, warning = FALSE}
data(sce_vdj)
```
We will set the seed so that the plots and results are consistent.
```{r}
set.seed(100)
```

## Filter the data

To begin, we will filter the data and extract the TCR information so that we 
can construct pseudobulks. 

Because the `colData` of this single-cell object is populated with the TCR 
information from `dandelion` in python (through this method: `dandelion` -> 
`anndata` -> `anndata2ri`, which essentially converts an `AnnData` object in 
python to `SingleCellExperiment` in R), we can directly use the 
`setupVdjPseudobulk` function to extract the TCR information and construct 
the pseudobulks.

Here, we also need to specify the `allowed_chain_status` to keep to the 
relevant contigs. Default for `allowed_chain_status` is `NULL`, which will 
keep all contigs. In the standard R workflow that starts from `scRepertoire`, 
we will assume that all the QC and filtering has already been handled by 
`scRepertoire`.

```{r, warning = FALSE}
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c(
        "Single pair", "Extra pair",
        "Extra pair-exception", "Orphan VDJ",
        "Orphan VDJ-exception"
    )
)
```

We can visualise the UMAP of the filtered data.
```{r, warning = FALSE}
plotUMAP(sce_vdj, color_by = "anno_lvl_2_final_clean")
```

## Milo object and neighbourhood graph construction

We will use miloR to create the pseudobulks based on the gene expression data. 
The goal is to construct a neighbourhood graph with many neighbors with which 
we can sample the representative neighbours to form the objects.
```{r, warning = FALSE}
library(miloR)
traj_milo <- Milo(sce_vdj)
milo_object <- buildGraph(traj_milo, k = 50, d = 20, reduced.dim = "X_scvi")
milo_object <- makeNhoods(milo_object, reduced_dims = "X_scvi", d = 20)
```
### Construct UMAP on milo neighbor graph

We can visualise this milo object using UMAP.
```{r, warning = FALSE}
milo_object <- miloUmap(milo_object)
```
```{r}
plotUMAP(milo_object,
    color_by = "anno_lvl_2_final_clean",
    dimred = "UMAP_knngraph"
)
```

## Construct pseudobulked VDJ feature space

Next, we will construct the pseudobulked VDJ feature space using the 
neighbourhood graph constructed above. We will also run PCA on the 
pseudobulked VDJ feature space.
```{r}
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")

pb.milo <- runPCA(pb.milo, assay.type = "Feature_space")
```

We can visualise the PCA of the pseudobulked VDJ feature space.
```{r}
plotPCA(pb.milo, color_by = "anno_lvl_2_final_clean")
```

## TCR trajectory inference using Absorbing Markov Chain

In the original `dandelion` python package, the trajectory inference is done 
using the `palantir` package. Here, we implement the absorbing markov chain 
approach in dandelionR to infer the trajectory, leveraging on `destiny` for 
diffusion map computation.

### Define root and branch tips
```{r}
library(SingleCellExperiment)

# extract the PCA matrix
pca <- t(as.matrix(reducedDim(pb.milo, type = "PCA")))
# define the CD8 terminal cell as the top-most cell and CD4 terminal cell as
# the bottom-most cell
branch.tips <- c(which.max(pca[2, ]), which.min(pca[2, ]))
names(branch.tips) <- c("CD8+T", "CD4+T")
# define the start of our trajectory as the right-most cell
root <- which.max(pca[1, ])
```

### Construct diffusion map
```{r, warning = FALSE}
library(destiny)
# Run diffusion map on the PCA
feature_space <- t(assay(pb.milo, "Feature_space"))
dm <- DiffusionMap(as.matrix(feature_space), n_pcs = 50, n_eigs = 10)
```

### Compute diffussion pseudotime on diffusion map
```{r}
dif.pse <- DPT(dm, tips = c(root, branch.tips), w_width = 0.1)
```

```{r, message=FALSE}
# the root is automatically called DPT + index of the root cell
DPTroot <- paste0("DPT", root)
# store pseudotime in milo object
pb.milo$pseudotime <- dif.pse[[DPTroot]]
# set the colours for pseudotime
pal <- colorRampPalette(rev((RColorBrewer::brewer.pal(9, "RdYlBu"))))(255)
plotPCA(pb.milo, color_by = "pseudotime") +
    scale_colour_gradientn(colours = pal)
```

### Markov chain construction on the pseudobulk VDJ feature space

```{r}
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    terminal_state = branch.tips,
    root_cell = root,
    pseudotime_key = "pseudotime"
)
```

### Visualising branch probabilities

With the Markov chain probabilities computed, we can visualise the branch 
probabilities towards CD4+ or CD8+ T-cell fate on the PCA plot.
```{r, message=FALSE}
plotPCA(pb.milo, color_by = "CD8+T") + scale_color_gradientn(colors = pal)
plotPCA(pb.milo, color_by = "CD4+T") + scale_color_gradientn(colors = pal)
```

## Transfer

The next step is to project the pseudotime and the branch probability 
information from the pseudobulks back to each cell in the dataset. If the cell 
do not belong to any of the pseudobulk, it will be removed. If a cell belongs 
to multiple pseudobulk samples, its value should be calculated as a weighted 
average of the corresponding values from each pseudobulk, where each weight is 
inverse of the size of the pseudobulk.

### Project pseudobulk data to each cell
```{r}
cdata <- projectPseudotimeToCell(milo_object, pb.milo, value_key = c("pseudotime", "CD8+T", "CD4+T"))
```

### Visualise the trajectory data on a per cell basis
```{r, message=FALSE}
plotUMAP(cdata, color_by = "anno_lvl_2_final_clean", dimred = "UMAP_knngraph")
plotUMAP(cdata, color_by = "pseudotime", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD4+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
plotUMAP(cdata, color_by = "CD8+T", dimred = "UMAP_knngraph") +
    scale_color_gradientn(colors = pal)
```

And that's it! We have successfully inferred the trajectory of the T-cells in 
this dataset!

## Session info

```{r, warning = FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getPbs.R
\name{.getPbs}
\alias{.getPbs}
\title{.getPbs}
\usage{
.getPbs(pbs, col_to_bulk, milo, verbose = TRUE)
}
\arguments{
\item{pbs}{pbs parameter provided by vdjPseudobulk(),  cells by pseudobulks
matrix or NULL}

\item{col_to_bulk}{col_to_bulk parameter provided by vdjPseudobulk(),
column's name of colData from milo}

\item{milo}{SingleCellExperiment object}

\item{verbose}{logical, whether to print messages}
}
\value{
a cell x pseudobulk matrix
}
\description{
Helper function to ensure we have cells by pseudobulks matrix which we can
use for pseudobulking.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.subsetSce}
\alias{.subsetSce}
\title{Subset sce with given parameter}
\usage{
.subsetSce(sce, subsetby, groups, verbose)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{subsetby}{subsetby Character. Name of a \code{colData} column for
subsetting. given by setupVdjPsudobulk.}

\item{groups}{Character vector. Specifies the subset condition for filtering.
given by setupVdjPsudobulk.}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
subsetted SingleCellExperiment object
}
\description{
Subset sce with given parameter
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{.normalizePerVDJ}
\alias{.normalizePerVDJ}
\title{function to normalize a specific kind of VDJ gene in feature space}
\usage{
.normalizePerVDJ(
  pseudo_vdj_feature,
  col_n,
  renormalize,
  define.mask,
  milo,
  min_count
)
}
\arguments{
\item{pseudo_vdj_feature}{constructed feature space}

\item{col_n}{name of column to extract the VDJ information}

\item{renormalize}{Whether to renormalize the matrix}

\item{define.mask}{logical vector determine whether the V/D/J gene
should be masked when normalizing}

\item{milo}{Milo or SingleCellExperiment object provided by user}

\item{min_count}{the minim count of a V/D/J gene}
}
\value{
feature space normalized on specifed V/D/J gene
}
\description{
function to normalize a specific kind of VDJ gene in feature space
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markovProbability.R
\name{.addColData}
\alias{.addColData}
\title{add the calculated probability to the colData}
\usage{
.addColData(probabilities_proj, terminal_state, milo, verbose)
}
\arguments{
\item{probabilities_proj}{the probabilities need to be stored}

\item{terminal_state}{Integer. The index of the terminal state in the Markov
chain, passed from markovProbability}

\item{milo}{the milo object provided by user}

\item{verbose}{logical, print warnings.}
}
\value{
a Milo object with probabilties and pseudotime in its colData slot
}
\description{
add the calculated probability to the colData
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{.determExtractColN}
\alias{.determExtractColN}
\title{determine the columns in the colData where the main VDJ information is stored}
\usage{
.determExtractColN(extract_cols, mode_option, milo)
}
\arguments{
\item{extract_cols}{names of columns in the colData where the main VDJ
information stores, passed from vdjPseudobulk}

\item{mode_option}{Specifies the mode for extracting V(D)J genes}

\item{milo}{Milo or SingleCellExperiment object provided by user}
}
\value{
a character vector stores the names of columns in the colData where
the main VDJ information stores
}
\description{
determine the columns in the colData where the main VDJ information is stored
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{setupVdjPseudobulk}
\alias{setupVdjPseudobulk}
\title{Preprocess V(D)J Data for Pseudobulk Analysis}
\usage{
setupVdjPseudobulk(
  sce,
  mode_option = c("abT", "gdT", "B"),
  already.productive = TRUE,
  productive_cols = NULL,
  productive_vj = TRUE,
  productive_vdj = TRUE,
  allowed_chain_status = NULL,
  subsetby = NULL,
  groups = NULL,
  extract_cols = NULL,
  filter_unmapped = TRUE,
  check_vj_mapping = c(TRUE, TRUE),
  check_vdj_mapping = c(TRUE, FALSE, TRUE),
  check_extract_cols_mapping = NULL,
  remove_missing = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{sce}{A \code{SingleCellExperiment} object. V(D)J data should be contained
in \code{colData} for filtering.}

\item{mode_option}{Optional character. Specifies the mode for extracting
V(D)J genes.
If \code{NULL}, \code{extract_cols} must be specified. Default is \code{NULL}.}

\item{already.productive}{Logical. Whether the data has already been filtered
for productivity.
If \code{TRUE}, skips productivity filtering. Default is \code{FALSE}.}

\item{productive_cols}{Character vector. Names of \code{colData} columns used for
productivity filtering.
Default is \code{NULL}.}

\item{productive_vj}{Logical. If \code{TRUE}, retains cells where the main
VJ chain is productive.
Default is \code{TRUE}.}

\item{productive_vdj}{Logical. If \code{TRUE}, retains cells where the
main VDJ chain is productive.
Default is \code{TRUE}.}

\item{allowed_chain_status}{Character vector. Specifies chain statuses to
retain. Valid options
include\code{`c('single pair', 'Extra pair', 'Extra pair-exception',
'Orphan VDJ', 'Orphan VDJ-exception')`}. Default is \code{NULL}.}

\item{subsetby}{Character. Name of a \code{colData} column for subsetting.
Default is \code{NULL}.}

\item{groups}{Character vector. Specifies the subset condition for filtering.
Default is \code{NULL}.}

\item{extract_cols}{Character vector. Names of \code{colData} columns where V(D)J
information is
stored, used instead of the standard columns. Default is \code{NULL}.}

\item{filter_unmapped}{Logic. Whether to filter unmapped data. Default
is TRUE.}

\item{check_vj_mapping}{Logic vector. Whether to check for VJ mapping.
Default is \code{c(TRUE, TRUE)}.
\itemize{
\item If the first element is TRUE, function will filter the unmapped data in V
gene of the VJ chain
\item If the second element is TRUE, function will filter the unmapped data in J
gene of the VJ chain
}}

\item{check_vdj_mapping}{Logic vector. Specifies columns to check for
VDJ mapping. Default
is \verb{c(TRUE, FALSE, 'TRUE)}.
\itemize{
\item If the first element is TRUE, function will filter the unmapped data in V
gene of the VDJ chain
\item If the second element is TRUE, function will filter the unmapped data in D
gene of the VDJ chain
\item If the third element is TRUE, function will filter the unmapped data in J
gene of the VDJ chain
}}

\item{check_extract_cols_mapping}{Character vector. Specifies columns related
to \code{extract_cols}
for mapping checks. Default is \code{NULL}.}

\item{remove_missing}{Logical. If \code{TRUE}, removes cells with contigs matching
the filter.
If \code{FALSE}, masks them with uniform values. Default is \code{TRUE}.}

\item{verbose}{Logical. Whether to print messages. Default is \code{TRUE}.}
}
\value{
filtered SingleCellExperiment object
}
\description{
This function preprocesses single-cell V(D)J sequencing data for
pseudobulk analysis. It filters data based on productivity and chain status,
subsets data, extracts main V(D)J genes, and removes unmapped entries.
}
\details{
The function performs the following preprocessing steps:
\itemize{
\item \strong{Productivity Filtering}:
\itemize{
\item Skipped if \code{already.productive = TRUE}.
\item Filters cells based on productivity using \code{productive_cols} or standard
\code{colData} columns named \verb{productive_\{mode_option\}_\{type\}} (where \code{type}
is 'VDJ' or 'VJ').
\item \emph{mode_option}
\itemize{
\item function will check colData(s) named
\verb{productive_\{mode_option\}_\{type\}}, where type should be 'VDJ' or 'VJ'
or both, depending on values of productive_vj and productive_vdj.
\item If set as \code{NULl}, the function needs the option 'extract_cols' to be
specified
}
\item \emph{productive_cols}
\itemize{
\item must be be specified when productivity filtering is need to conduct
and mode_option is NULL.
\item where VDJ/VJ information is stored so that this will be used
instead of the standard columns.
}
\item \emph{productive_vj, productive_vdj}
\itemize{
\item If \code{TRUE}, cell will only be kept if the main V(D)J chain
is productive
}
}
\item \strong{Chain Status Filtering}:
\itemize{
\item Retains cells with chain statuses specified by \code{allowed_chain_status}.
}
\item \strong{Subsetting}:
\itemize{
\item Conducted only if both \code{subsetby} and \code{groups} are provided.
\item Retains cells matching the \code{groups} condition in the \code{subsetby} column.
}
\item \strong{Main V(D)J Extraction}:
\itemize{
\item Uses \code{extract_cols} to specify custom columns for
extracting V(D)J information.
}
\item \strong{Unmapped Data Filtering}:
\itemize{
\item decided to removes or masks cells based on \code{filter_unmapped}.
\item Checks specific columns for unclear mappings using \code{check_vj_mapping},
\code{check_vdj_mapping}, or \code{check_extract_cols_mapping}.
\item \emph{filter_unmapped}
\itemize{
\item pattern to be filtered from object.
\item If is set to be \code{NULL}, the filtering process will not start
}
\item \emph{check_vj_mapping, check_vdj_mapping}
\itemize{
\item only \code{colData} specified by these arguments
(\code{check_vj_mapping} and \code{check_vdj_mapping}) will be checked
for unclear mappings
}
\item \emph{check_extract_cols_mapping, related to extract_cols}
\itemize{
\item Only \code{colData} specified by the argument will be checked for
unclear mapping, the colData should first specified by extract_cols
}
\item remove_missing
\itemize{
\item If \code{TRUE}, will remove cells with contigs matching the filter from the
object.
\item If \code{FALSE}, will mask them with a uniform value dependent on
the column name.
}
}
}
}
\examples{

# load data
data(sce_vdj)
# check the dimension
dim(sce_vdj)
# filtered the data
sce_vdj <- setupVdjPseudobulk(
    sce = sce_vdj,
    mode_option = "abT", # set the mode to alpha-beta TCR
    allowed_chain_status = c("Single pair", "Extra pair"),
    already.productive = FALSE
) # need to filter the unproductive cells
# check the remaining dim
dim(sce_vdj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{demo_airr}
\alias{demo_airr}
\title{Example AIRR Dataset for V(D)J Analysis}
\format{
A \code{SingleCellExperiment} object with the following slots:
\describe{
\item{\code{list}}{
List of \code{DataFrames} containing the standardised AIRR data for
each sample. \cr
For information of AIRR rearrangements, see the AIRR Community
standards at \url{https://docs.airr-community.org/}.
}
}
}
\source{
Suo et al., 2024, \emph{Nature Biotechnology}. \cr
\url{https://www.nature.com/articles/s41587-023-01734-7}.
}
\usage{
data(demo_airr)
}
\description{
The \code{demo_airr} object is a list of AIRR data frames from a down-sampled
demo dataset derived from Suo et al., 2024, \emph{Nature Biotechnology}.\cr
This dataset is used in vignettes to demonstrate workflows for
V(D)J analysis.\cr
For details, see the original publication at
\url{https://www.nature.com/articles/s41587-023-01734-7}.\cr
The original files are available at
\url{https://github.com/zktuong/dandelion-demo-files}.
}
\examples{
data(demo_airr)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/determMultiscaleSpace.R
\name{.determineMultiscaleSpace}
\alias{.determineMultiscaleSpace}
\title{.determineMultiscaleSpace}
\usage{
.determineMultiscaleSpace(diffusionmap, n_eigs = NULL)
}
\arguments{
\item{diffusionmap}{DiffusionMap object}

\item{n_eigs}{integer, default is NULL. Number of eigen vectors to use.
\itemize{
\item If is not specified, the number of eigen vectors will be determined using
the eigen gap.
}}
}
\value{
dataframe
}
\description{
.determineMultiscaleSpace
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.generateExtractColumn}
\alias{.generateExtractColumn}
\title{Check whether the columns with specified names exist, if not, create them
with CTgene columns}
\usage{
.generateExtractColumn(sce, extract_cols, verbose)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{extract_cols}{column names we aim to extract information from}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
SingleCellExperiment with columns containing VDJ information in the
names we've specified.
}
\description{
Check whether the columns with specified names exist, if not, create them
with CTgene columns
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.filterProductivity}
\alias{.filterProductivity}
\title{filer out cell with unproductive chain}
\usage{
.filterProductivity(
  sce,
  mode_option,
  productive_cols,
  productive_vj,
  productive_vdj,
  verbose
)
}
\arguments{
\item{sce}{SingleCellExperiment input}

\item{mode_option}{check setupVdjPseudobulk for detailed explanation}

\item{productive_vj}{If \code{TRUE}, retains cells where the main VJ chain is
productive.}

\item{productive_vdj}{If \code{TRUE}, retains cells where the main VDJ chain is
productive.}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
SingleCellExperiment object after filtering on producive chain
}
\description{
filer out cell with unproductive chain
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.filterUnmapped}
\alias{.filterUnmapped}
\title{Filter out cell with unclear mapping in VDJ information}
\usage{
.filterUnmapped(
  sce,
  mode_option,
  check_vj_mapping,
  check_vdj_mapping,
  main_cols,
  check_extract_cols_mapping,
  remove_missing,
  verbose
)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{mode_option}{see document of setupVdjPseudobulk for explanation}

\item{check_vj_mapping}{logical vector to set whether to check V and J gene
in VJ chain, passed from setupVdjPseudobulk}

\item{check_vdj_mapping}{logical vector to set whether to check
V, D and J gene in VDJ chain, passed from setupVdjPseudobulk}

\item{main_cols}{column names in colData in which The information of
main chain stores}

\item{check_extract_cols_mapping}{character vector,the names of columns that
needs to be checked, passed from setupVdjPseudobulk}

\item{remove_missing}{option for removing the unclear mappin or just mask it,
passed from setupVdjPseudobulk}

\item{verbose}{logical, print messages.}
}
\value{
filtered SingleCellExperiment object
}
\description{
Filter out cell with unclear mapping in VDJ information
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructMarkovChain.R
\name{.constructMarkovChain}
\alias{.constructMarkovChain}
\title{.constructMarkovChain}
\usage{
.constructMarkovChain(wp_data, knn., pseudotime, waypoints, vb, use_RANN)
}
\arguments{
\item{wp_data}{Multi scale data of the waypoints}

\item{knn.}{Number of nearest neighbors for graph construction}

\item{pseudotime}{pseudotime ordering of cells}

\item{waypoints}{integer vector, index of selected waypoint used to}

\item{vb}{whether to print messages}

\item{use_RANN}{parameter to make user choose
whether to use RANN to construct Markov chain,
or keep using bluster}
}
\value{
transition matrix of the markov chain
}
\description{
Markov chain construction
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitCTgene.R
\name{chainAssign}
\alias{chainAssign}
\title{Assign the V(D)J gene to the right chain.}
\usage{
chainAssign(vec, num, min_len, max_len)
}
\arguments{
\item{vec}{vector of V(D)J genes to assign to the right chain.}

\item{num}{number of genes to return. should be 2(vj) or 3(vdj)}

\item{min_len}{minimum length of the vector to account for missing constant gene.}

\item{max_len}{maximum length of the vector to account for multiple chains.}
}
\value{
list contain vector of VJ + VDJ of the cell input
}
\description{
Assign the V(D)J gene to the right chain.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitCTgene.R
\name{splitCTgene}
\alias{splitCTgene}
\title{Split the V(D)J genes from \code{CTgene} column and store them separately.}
\usage{
splitCTgene(sce)
}
\arguments{
\item{sce}{SingleCellExperiment object after conducting
scRepertoire::combineTCR()}
}
\value{
list contain vector of VJ & VDJ genes from each cell
}
\description{
Split the V(D)J genes from \code{CTgene} column and store them separately.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dandelionR.R
\docType{package}
\name{dandelionR}
\alias{dandelionR-package}
\alias{dandelionR}
\title{dandelionR: Single-cell immune repertoire trajectory analysis}
\description{
dandelionR is an R package for performing single-cell immune repertoire
trajectory analysis, based on the original python implementation.
It provides the necessary functions to interface with scRepertoire and a
custom implementation of an absorbing Markov chain for pseudotime
inference, inspired by the Palantir Python package.
}
\section{Main functions}{

\itemize{
\item \code{\link{setupVdjPseudobulk}}: Preprocess V(D)J Data for Pseudobulk
Analysis.
\item \code{\link{vdjPseudobulk}}: Generate Pseudobulk V(D)J Feature Space.
\item \code{\link{markovProbability}}: Markov Chain Construction and
Probability Calculation.
\item \code{\link{projectPseudotimeToCell}}: Project Pseudotime and Branch
Probabilities to Single Cells.
}
}

\section{Vignettes}{

See the package vignettes for detailed workflows:
\code{vignette('dandelionR')}
}

\section{Installation}{

To install from Bioconductor, use:
\preformatted{
if (!requireNamespace('BiocManager', quietly = TRUE))
    install.packages('BiocManager')
BiocManager::install('dandelionR')
}
}

\seealso{
Useful links:
\itemize{
  \item \url{https://www.github.com/tuonglab/dandelionR/}
  \item Report bugs at \url{https://www.github.com/tuonglab/dandelionR/issues}
}

}
\author{
\strong{Maintainer}: Kelvin Tuong \email{z.tuong@uq.edu.au} (\href{https://orcid.org/0000-0002-6735-6808}{ORCID})

Authors:
\itemize{
  \item Jiawei Yu \email{jiawei.yu@uq.edu.au} (\href{https://orcid.org/0009-0005-9170-7881}{ORCID})
  \item Nicholas Borcherding \email{borcherding@wustl.edu} (\href{https://orcid.org/0000-0003-1427-6342}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getPbs.R
\name{.getPbsPerCol}
\alias{.getPbsPerCol}
\title{.getPbsPerCol}
\usage{
.getPbsPerCol(pbs.col, anno_col, milo, pbs)
}
\arguments{
\item{pbs.col}{DataFrame object used to store the result of each iteration}

\item{anno_col}{colname where to generate the metadata from}

\item{milo}{milo or SingleCellExperiment objects provided by user}

\item{pbs}{dgeMatrix, cell x pseudobulk binary matrix}
}
\value{
DataFrame object, serve as part of metadata of the new milo object
}
\description{
function used in Reduce to get the PbsCol
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{.packFeatureSpace}
\alias{.packFeatureSpace}
\title{Pack the normalized feature space into new Milo object}
\usage{
.packFeatureSpace(pbs, col_to_take, milo, pseudo_vdj_feature)
}
\arguments{
\item{pbs}{cell x pseudobulk adjacent matrix}

\item{col_to_take}{Optional character or vector of characters.
Specifies names of colData of milo that need to identify the most
common value for each pseudobulk}

\item{milo}{Milo or SingleCellExperiment object provided by user}

\item{pseudo_vdj_feature}{VDJ feature space}
}
\value{
Milo object with VDJ feature space stored in its assay
}
\description{
The metadata will derived from the original milo
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructMarkovChain.R
\name{.removeEdge}
\alias{.removeEdge}
\title{function used in Reduce to remove KNN's backward edges except for
edges that are within the computed standard deviation}
\usage{
.removeEdge(Knn, i, rem_edges)
}
\arguments{
\item{Knn}{weight KNN adjacent matrix}

\item{i}{the iteration number}

\item{rem_edges}{the edges that need to be removes}
}
\value{
an updated matrix after one round of iteration
}
\description{
function used in Reduce to remove KNN's backward edges except for
edges that are within the computed standard deviation
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sce_vdj}
\alias{sce_vdj}
\title{Example Dataset for V(D)J Analysis}
\format{
A \code{SingleCellExperiment} object with the following slots:
\describe{
\item{\code{colData}}{
A \code{DataFrame} containing metadata about each sample, corresponding
to \code{obs} in AnnData (Python).
The following columns are relevant for vignette usage:
\describe{
\item{\code{productive_(mode)_VDJ}, \code{productive_(mode)_VJ}}{
Factors indicating whether the heavy or light chain is
productive. \code{mode} refers to the
extraction mode for V(D)J genes and can be one of:
\itemize{
\item{\code{'abT'}}: TCR alpha-beta
\item{\code{'gdT'}}: TCR gamma-delta
\item{\code{'B'}}: BCR
}
}
\item{\code{Gene segment fields}}{
Gene segment annotations with column names in the format
\code{(v/d/j)_call_(mode)_(VDJ/VJ)}.
Examples include:
\itemize{
\item{\code{v_call_abT_VDJ}}: V gene for TCR alpha-beta
VDJ recombination
\item{\code{d_call_abT_VJ}}: D gene for TCR alpha-beta
VJ recombination
}
}
\item{\code{chain_status}}{
A factor describing the receptor chain's status.
}
\item{\code{anno_lvl_2_final_clean}}{
Cell type annotations.
}
}
}
\item{\code{int_colData}}{
A \code{DataFrame} containing additional assay metadata important for further
analysis. Includes:
\itemize{
\item{\code{X_scvi}}: A dimensionality reduction matrix from the
scVI model.
\item{\code{UMAP}}: A UMAP reduction matrix.
}
}
}
}
\source{
Suo et al., 2024, \emph{Nature Biotechnology}.\cr
\url{https://www.nature.com/articles/s41587-023-01734-7}.
}
\usage{
data(sce_vdj)
}
\description{
The \code{sce_vdj} object is a down-sampled demo dataset derived from
Suo et al., 2024, \emph{Nature Biotechnology}. \cr
This dataset is used in vignettes to demonstrate workflows for V(D)J
analysis. \cr For details, see the original
publication at \url{https://www.nature.com/articles/s41587-023-01734-7}.
}
\examples{
data(sce_vdj)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{.classCheck}
\alias{.classCheck}
\title{.classCheck}
\usage{
.classCheck(input, must)
}
\arguments{
\item{input}{the input need to be check}

\item{must}{the type we need}
}
\value{
whether or not the input is the correct class
}
\description{
check whether the input is with the correct class
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructMarkovChain.R
\name{.RANNinx}
\alias{.RANNinx}
\title{Calculate the weight adjacent matricks of knn graph and its index using RANN}
\usage{
.RANNinx(wp_data, knn.)
}
\arguments{
\item{wp_data}{Multi scale data of the waypoints}

\item{knn.}{Number of nearest neighbors for graph construction}
}
\value{
a list containing the weight adjacent matrix and index
}
\description{
Calculate the weight adjacent matricks of knn graph and its index using RANN
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitCTgene.R
\name{.collapse_nested_list}
\alias{.collapse_nested_list}
\title{Collapse a nested list}
\usage{
.collapse_nested_list(input_list)
}
\arguments{
\item{input_list}{input nested list.}
}
\value{
collapsed list
}
\description{
Collapse a nested list
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.extractVdj}
\alias{.extractVdj}
\title{Specify the columns which store VDJ information, and extract the main chain
from it}
\usage{
.extractVdj(sce, extract_cols, mode_option, verbose)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{extract_cols}{The setupVdjPseutobulk transfered parameter given by user
to specify the VDJ information columns}

\item{mode_option}{see document of setupVdjPseudobulk for
detailed explanation}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
SingleCellExperiment objects with column stores the information of
the main VDJ information in colData slot
}
\description{
Specify the columns which store VDJ information, and extract the main chain
from it
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/terminalStateFromMarkovChain.R
\name{.terminalStateFromMarkovChain}
\alias{.terminalStateFromMarkovChain}
\title{Determine terminal states using Markov chain if end states are not provided.}
\usage{
.terminalStateFromMarkovChain(
  Transmat,
  wp_data,
  pseudotime,
  waypoints,
  verbose
)
}
\arguments{
\item{Transmat}{Transition matrix}

\item{wp_data}{Multi scale data of the waypoints}

\item{pseudotime}{numeric vector, pseudotime of each pseudobulk}

\item{waypoints}{integer vector, waypoint selected to construct markov chain.}

\item{verbose}{Boolean, whether to print messages/warnings.}
}
\value{
terminal_state
}
\description{
Determine terminal states using Markov chain if end states are not provided.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.allowedChain}
\alias{.allowedChain}
\title{filtering cell without allowed chain status}
\usage{
.allowedChain(sce, allowed_chain_status, verbose)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{allowed_chain_status}{the chain needs to be retain, passed from
setupVdjPseudobulk}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
SingleCellExperiment object with allowed chain status
}
\description{
filtering cell without allowed chain status
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markovProbability.R
\name{markovProbability}
\alias{markovProbability}
\title{Markov Chain Construction and Probability Calculation}
\usage{
markovProbability(
  milo,
  diffusionmap,
  terminal_state = NULL,
  root_cell,
  knn = 30L,
  diffusiontime = NULL,
  pseudotime_key = "pseudotime",
  scale_components = TRUE,
  num_waypoints = 500,
  n_eigs = NULL,
  verbose = TRUE,
  use_RANN = TRUE
)
}
\arguments{
\item{milo}{A \code{Milo} or \code{SingleCellExperiment} object. This object should
have pseudotime stored in \code{colData}, which will be used to calculate
probabilities. If pseudotime is available in \code{milo}, it takes precedence over
the value provided through the \code{diffusiontime} parameter.}

\item{diffusionmap}{A \code{DiffusionMap} object corresponding to the \code{milo}
object. Used for Markov chain construction.}

\item{terminal_state}{Integer. The index of the terminal state in the Markov
chain.}

\item{root_cell}{Integer. The index of the root state in the Markov chain.}

\item{knn}{Integer. The number of nearest neighbors for graph construction.
Default is \code{30L}.}

\item{diffusiontime}{Numeric vector. If pseudotime is not stored in \code{milo},
this parameter can be used to provide pseudotime values to the function.}

\item{pseudotime_key}{Character. The name of the column in \code{colData} that
contains the inferred pseudotime.}

\item{scale_components}{Logical. If \code{TRUE}, the components will be scaled
before constructing the Markov chain. Default is \code{FALSE}.}

\item{num_waypoints}{Integer. The number of waypoints to sample when
constructing the Markov chain. Default is \code{500L}.}

\item{n_eigs}{integer, default is NULL. Number of eigen vectors to use.
\itemize{
\item If is not specified, the number of eigen vectors will be determined using
the eigen gap.
}}

\item{verbose}{Logical. If \code{TRUE}, print progress. Default is \code{TRUE}.}

\item{use_RANN}{parameter to make user choose
whether to use RANN to construct Markov chain,
or keep using bluster}
}
\value{
milo or SinglCellExperiment object with pseudotime, probabilities in
its colData
}
\description{
This function preprocesses data, constructs a Markov chain, and calculates
transition probabilities based on pseudotime information.
}
\examples{
data(sce_vdj)
# downsample to first 2000 cells
sce_vdj <- sce_vdj[, 1:2000]
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
set.seed(100)
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object,
    reduced_dims = "X_scvi",
    d = 20
)

# Construct Pseudobulked VDJ Feature Space
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")

# Define root and branch tips
pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
names(branch.tips) <- c("CD8+T", "CD4+T")
root <- which.min(pca[, 1])

# Construct Diffusion Map
dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)

# Markov Chain Construction
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    diffusiontime = dif.pse[[paste0("DPT", root)]],
    terminal_state = branch.tips,
    root_cell = root,
    pseudotime_key = "pseudotime"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getPbs.R
\name{.getPbsCol}
\alias{.getPbsCol}
\title{.getPbsCol}
\usage{
.getPbsCol(pbs, col_to_take, milo)
}
\arguments{
\item{pbs}{dgeMatrix, cell x pseudobulk binary matrix}

\item{col_to_take}{character vector, names of colData of milo that need to
be processed}

\item{milo}{Milo or SingleCellExperiment object}
}
\value{
pbs_col, a DataFrame which will be passed to the new
SingleCellExperiment object as colData of vdj x pseudobulk assays
}
\description{
Helper function to create the new pseudobulk object's coldata.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{.normalizeFeatureSpace}
\alias{.normalizeFeatureSpace}
\title{Normalize Feature Space}
\usage{
.normalizeFeatureSpace(
  pseudo_vdj_feature,
  extract_cols,
  min_count,
  renormalize,
  milo
)
}
\arguments{
\item{pseudo_vdj_feature}{constructed feature space}

\item{extract_cols}{names of columns to extract the VDJ information}

\item{min_count}{the minim count of a V/D/J gene}

\item{renormalize}{Whether to renormalize the matrix}

\item{milo}{Milo or SingleCellExperiment object provided by user}
}
\value{
normalized VDJ feature space
}
\description{
Make sure the sum of each V, D, and J gene within a pseudobulk equals to 1
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/projectProbability.R
\name{projectProbability}
\alias{projectProbability}
\title{Project Probabilities from Markov Chain to Pseudobulks}
\usage{
projectProbability(
  diffusionmap,
  waypoints,
  probabilities,
  t = 1,
  verbose = TRUE
)
}
\arguments{
\item{diffusionmap}{diffusion map, used to reconstruct
diffustion distance matrix}

\item{waypoints}{Integer vector. Indices of the waypoints used in
the Markov chain.}

\item{probabilities}{Numeric vector. Probabilities associated with
the waypoints, calculated from the Markov chain.}

\item{t}{Numeric. The diffusion time to be used in the projection.}

\item{verbose}{Boolean, whether to print messages/warnings.}
}
\value{
each pseudobulk's probabilites
}
\description{
This function projects probabilities calculated from a Markov chain onto
each pseudobulk based on a diffusion distance matrix.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitCTgene.R
\name{formatVdj}
\alias{formatVdj}
\title{Change the format of splitCTgene output.}
\usage{
formatVdj(gene_list)
}
\arguments{
\item{gene_list}{list containing the output from splitCTgene.}
}
\value{
list contain vector of VJ + VDJ information of the cell input
}
\description{
Change the format of splitCTgene output.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/terminalStateFromMarkovChain.R
\name{.determTerminal}
\alias{.determTerminal}
\title{.determTerminal}
\usage{
.determTerminal(terminal_states, i, dm_boudaries, wp_data)
}
\arguments{
\item{terminal_states}{integer vector to store the generated waypoint index}

\item{i}{iteration index}

\item{dm_boudaries}{index of the maxium or minium value of
transition matrix per row}

\item{wp_data}{Multi scale data of the waypoints}
}
\value{
integer vector store the index of waypoints serve as terminal state
}
\description{
function in Reduce to provide waypoints
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/projectPseudotimeToCell.R
\name{project_single_value}
\alias{project_single_value}
\title{Function to project pseudobulk-level values to single-cell level}
\usage{
project_single_value(x, y, value_name, verbose = TRUE)
}
\arguments{
\item{x}{Numeric vector, pseudobulk-level value to be projected.}

\item{y}{Matrix (pseudobulk x cell), used to project x back to cell level.}

\item{value_name}{Character, name of the value being projected.}

\item{verbose}{Boolean, whether to print messages/warnings.}
}
\value{
Numeric vector of projected values at cell level.
}
\description{
Function to project pseudobulk-level values to single-cell level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/differentiationProbabilities.R
\name{differentiationProbabilities}
\alias{differentiationProbabilities}
\title{Compute Branch Probabilities Using Markov Chain}
\usage{
differentiationProbabilities(
  wp_data,
  terminal_states = NULL,
  knn = 30L,
  pseudotime,
  waypoints,
  verbose = TRUE,
  use_RANN = TRUE
)
}
\arguments{
\item{wp_data}{A multi-scale data matrix or data frame representing the
waypoints.}

\item{terminal_states}{Integer vector. Indices of the terminal states.
Default is \code{NULL}.}

\item{knn}{Integer. Number of nearest neighbors for graph construction.
Default is \code{30L}.}

\item{pseudotime}{Numeric vector. Pseudotime ordering of cells.}

\item{waypoints}{Integer vector. Indices of selected waypoints used to
construct the Markov chain.}

\item{verbose}{Boolean, whether to print messages/warnings.}

\item{use_RANN}{parameter to make user choose
whether to use RANN to construct Markov chain,
or keep using bluster}
}
\value{
A numeric matrix or data frame containing branch probabilities
for each waypoint.
}
\description{
This function calculates branch probabilities for differentiation
trajectories based on a Markov chain constructed from waypoint data and
pseudotime ordering.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setupVdjPseudobulk.R
\name{.generateExtractName}
\alias{.generateExtractName}
\title{Generate the name of columns with given parameter}
\usage{
.generateExtractName(sce, mode_option, verbose)
}
\arguments{
\item{sce}{SingleCellExperiment object input}

\item{mode_option}{see document of setupVdjPseudobulk for explanation}

\item{verbose}{logical, print messages. Default is \code{TRUE}.}
}
\value{
a vecotor of colnames we need to perform main chain extraction
}
\description{
Generate the name of columns with given parameter
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/maxMinSampling.R
\name{.maxMinSampling}
\alias{.maxMinSampling}
\title{.maxMinSampling}
\usage{
.maxMinSampling(datas, num_waypoints, verbose = TRUE)
}
\arguments{
\item{datas}{data matrix along which to sample the waypoints, usually
diffusion components}

\item{num_waypoints}{number of waypoints to sample}

\item{verbose}{logical, print progress}
}
\value{
Series reprenting the sampled waypoints
}
\description{
function for max min sampling of waypoints
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/miloUmap.R
\name{miloUmap}
\alias{miloUmap}
\title{Perform UMAP on the Adjacency Matrix of a Milo Object}
\usage{
miloUmap(
  milo,
  slot_name = "UMAP_knngraph",
  n_neighbors = 50L,
  metric = "euclidean",
  min_dist = 0.3,
  use_graph = TRUE,
  ...
)
}
\arguments{
\item{milo}{the milo object with knn graph that needed to conduct umap on.}

\item{slot_name}{character, with default 'UMAP_knngraph'.
\itemize{
\item The slot name in reduceDim where the result store
}}

\item{n_neighbors}{integer, with default 50L.
\itemize{
\item the size of local neighborhood (in terms of number of
neighboring sample points) used for manifold approximation.
\item Here, the goal is to create large enough neighborhoods to capture
the local manifold structure to allow for hypersampling.
}}

\item{metric}{character, with default 'euclidean'
\itemize{
\item the choice of metric used to measure distance to find nearest neighbors.
Default is 'euclidean'.
}}

\item{min_dist}{numeric, with default 0.3
\itemize{
\item the minimum distance between points in the low dimensional space
}}

\item{use_graph}{Logical, default TRUE.
\itemize{
\item Whether to run UMAP on the graph adjacency matrix (TRUE) as in Dandelion,
or directly on the latent space (FALSE) for faster performance.
}}

\item{...}{other parameters passed to uwot::umap}
}
\value{
milo object with umap reduction
}
\description{
This function uses \code{uwot::umap} to perform UMAP dimensionality
reduction on the adjacency matrix of the KNN graph in a Milo object.
}
\examples{
data(sce_vdj)
# downsample to just 1000 cells
sce_vdj <- sce_vdj[, 1:1000]
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object,
    reduced_dims = "X_scvi", d = 20
)

# Construct UMAP on Milo Neighbor Graph
milo_object <- miloUmap(milo_object)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{vdjPseudobulk}
\alias{vdjPseudobulk}
\title{Generate Pseudobulk V(D)J Feature Space}
\usage{
vdjPseudobulk(
  milo,
  pbs = NULL,
  col_to_bulk = NULL,
  extract_cols = c("v_call_abT_VDJ_main", "j_call_abT_VDJ_main", "v_call_abT_VJ_main",
    "j_call_abT_VJ_main"),
  mode_option = c("abT", "gdT", "B"),
  col_to_take = NULL,
  normalise = TRUE,
  renormalize = FALSE,
  min_count = 1L,
  verbose = TRUE
)
}
\arguments{
\item{milo}{A \code{Milo} or \code{SingleCellExperiment} object containing V(D)J data.}

\item{pbs}{Optional. A binary matrix with cells as rows and pseudobulk groups
as columns.
\itemize{
\item If \code{milo} is a \code{Milo} object, this parameter is not required.
\item If \code{milo} is a \code{SingleCellExperiment} object, either \code{pbs} or
\code{col_to_bulk} must be provided.
}}

\item{col_to_bulk}{Optional character or character vector. Specifies
\code{colData} column(s) to generate \code{pbs}. If multiple columns are provided,
they will be combined. Default is \code{NULL}.
\itemize{
\item If \code{milo} is a \code{Milo} object, this parameter is not required.
\item If \code{milo} is a \code{SingleCellExperiment} object, either \code{pbs} or
\code{col_to_bulk} must be provided.
}}

\item{extract_cols}{Character vector. Specifies column names where V(D)J
information is stored. Default is \verb{c('v_call_abT_VDJ_main', 'j_call_abT_VDJ_main', ' 'v_call_abT_VJ_main', 'j_call_abT_VJ_main')}.}

\item{mode_option}{Character. Specifies the mode for extracting V(D)J genes.
Must be one of \code{c('B', 'abT', 'gdT')}. Default is \code{'abT'}.
\itemize{
\item Note: This parameter is considered only when \code{extract_cols = NULL}.
\item If \code{NULL}, uses column names such as \code{v_call_VDJ} instead of
\code{v_call_abT_VDJ}.
}}

\item{col_to_take}{Optional character or vector of characters. Specifies
names of colData of milo that need to identify the most common value for each
pseudobulk Default is \code{NULL}.}

\item{normalise}{Logical. If \code{TRUE}, scales the counts of each V(D)J gene
group to 1 for each pseudobulk. Default is \code{TRUE}.}

\item{renormalize}{Logical. If \code{TRUE}, rescales the counts of each V(D)J gene
group to 1 for each pseudobulk after removing 'missing' calls. Useful when
\code{setupVdjPseudobulk()} was run with \code{remove_missing = FALSE}.
Default is \code{FALSE}.}

\item{min_count}{Integer. Sets pseudobulk counts in V(D)J gene groups with
fewer than this many non-missing calls to 0. Default is \code{1}.}

\item{verbose}{Logical. If \code{TRUE}, prints messages and warnings.
Default is \code{TRUE}.}
}
\value{
SingleCellExperiment object
}
\description{
This function creates a pseudobulk V(D)J feature space from single-cell data,
aggregating V(D)J information into pseudobulk groups. It supports input as
either a \code{Milo} object or a \code{SingleCellExperiment} object.
}
\details{
This function aggregates V(D)J data into pseudobulk groups
based on the following logic:
\itemize{
\item \strong{Input Requirements}:
\item If \code{milo} is a \code{Milo} object, neither \code{pbs} nor \code{col_to_bulk} is required.
\item If \code{milo} is a \code{SingleCellExperiment} object, the user must provide either
\code{pbs} or \code{col_to_bulk}.
\item \strong{Normalization}:
\item When \code{normalise = TRUE}, scales V(D)J counts to 1 for each pseudobulk
group.
\item When \code{renormalize = TRUE}, rescales the counts after removing
'missing' calls.
\item \strong{Mode Selection}:
\item If \code{extract_cols = NULL}, the function relies on \code{mode_option} to
determine which V(D)J columns to extract.
\item \strong{Filtering}:
\item Uses \code{min_count} to filter pseudobulks with insufficient counts for
V(D)J groups.
}
}
\examples{
data(sce_vdj)
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object,
    reduced_dims = "X_scvi",
    d = 20
)

# Construct pseudobulked VDJ feature space
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/projectPseudotimeToCell.R
\name{projectPseudotimeToCell}
\alias{projectPseudotimeToCell}
\title{Project Pseudotime and Branch Probabilities to Single Cells}
\usage{
projectPseudotimeToCell(
  milo,
  pb_milo,
  value_key = NULL,
  suffix = "",
  verbose = TRUE
)
}
\arguments{
\item{milo}{A \code{SingleCellExperiment} or \code{Milo} object. Represents single-cell
data where pseudotime and branch probabilities will be projected.}

\item{pb_milo}{A pseudobulk \code{Milo} object. Contains aggregated branch
probabilities and pseudotime information to be transferred to single cells.}

\item{value_key}{Character. The column name in \code{colData} of \code{pb_milo}
that contains the value that is needed to be projected back. Default is \code{NULL}.}

\item{suffix}{Character. A suffix to be added to the new column names in
\code{colData}. Default is an empty string (\code{''}).}

\item{verbose}{Boolean, whether to print messages/warnings.}
}
\value{
subset of milo or SingleCellExperiment object where cell that do not
belong to any neighbourhood are removed and projected pseudotime information
stored colData
}
\description{
This function projects pseudotime and branch probabilities from pseudobulk
data to single-cell resolution (\code{milo}). The results are stored in the
\code{colData} of the \code{milo} object.
}
\examples{
data(sce_vdj)
# downsample to first 2000 cells
sce_vdj <- sce_vdj[, 1:2000]
sce_vdj <- setupVdjPseudobulk(sce_vdj,
    already.productive = FALSE,
    allowed_chain_status = c("Single pair", "Extra pair")
)
# Build Milo Object
set.seed(100)
milo_object <- miloR::Milo(sce_vdj)
milo_object <- miloR::buildGraph(milo_object,
    k = 50, d = 20,
    reduced.dim = "X_scvi"
)
milo_object <- miloR::makeNhoods(milo_object,
    reduced_dims = "X_scvi",
    d = 20
)

# Construct Pseudobulked VDJ Feature Space
pb.milo <- vdjPseudobulk(milo_object, col_to_take = "anno_lvl_2_final_clean")
pb.milo <- scater::runPCA(pb.milo, assay.type = "Feature_space")

# Define root and branch tips
pca <- t(as.matrix(SingleCellExperiment::reducedDim(pb.milo, type = "PCA")))
branch.tips <- c(which.min(pca[, 2]), which.max(pca[, 2]))
names(branch.tips) <- c("CD8+T", "CD4+T")
root <- which.min(pca[, 1])

# Construct Diffusion Map
dm <- destiny::DiffusionMap(t(pca), n_pcs = 10, n_eigs = 5)
dif.pse <- destiny::DPT(dm, tips = c(root, branch.tips), w_width = 0.1)

# Markov Chain Construction
pb.milo <- markovProbability(
    milo = pb.milo,
    diffusionmap = dm,
    diffusiontime = dif.pse[[paste0("DPT", root)]],
    terminal_state = branch.tips,
    root_cell = root,
    pseudotime_key = "pseudotime"
)
# Project Pseudobulk Data
projected_milo <- projectPseudotimeToCell(
    milo_object,
    pb.milo,
    value_key = c("pseudotime", "CD8+T", "CD4+T")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterCells.R
\name{.filterCells}
\alias{.filterCells}
\title{.filterCells}
\usage{
.filterCells(
  sce,
  col_n,
  filter_pattern = ",|None|No_contig",
  remove_missing = TRUE
)
}
\arguments{
\item{sce}{SingleCellExperiment object, adata in python
data after combineTCR, contain both vdj and seq}

\item{col_n}{mode for extraction the V(D)J genes.}

\item{filter_pattern}{character string,
optional ',|None|No_contig' by default}

\item{remove_missing}{bool, True by default
\itemize{
\item If \code{TRUE}, will remove cells with contigs matching the filter from
the object.
\item If \code{FALSE}, will mask them with a uniform value dependent on the column
name.
}}
}
\value{
filtered SingleCellExperiment object according to the parameter.
}
\description{
Helper function that identifies filter_pattern hits in determined column of
sce, and then either removes the offeending cells or masks
the matched values with a uniform value of '(column's name)_missing'
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/maxMinSampling.R
\name{.findNewWaypoints}
\alias{.findNewWaypoints}
\title{function used in Reduce to find new waypoint in an iteration}
\usage{
.findNewWaypoints(iterdists, k, vecs, ind, datas)
}
\arguments{
\item{iterdists}{a list containing both waypoints deteted in
the former iterations and the distance matrix used to find waypoints}

\item{k}{the iteration number}

\item{vecs}{a numeric vector used to calculate distance of waypoints to
each points}

\item{ind}{colnames}
}
\value{
a list containing updated distance matrix and new waypoints
}
\description{
function used in Reduce to find new waypoint in an iteration
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/maxMinSampling.R
\name{.waypiontsPerCol}
\alias{.waypiontsPerCol}
\title{find the waypoints according to certain columns of data}
\usage{
.waypiontsPerCol(waypoints, ind, datas, no.iterations)
}
\arguments{
\item{waypoints}{integer vector used to store waypoints}

\item{ind}{columns' colnames}

\item{datas}{scaled diffusionmap}
}
\value{
a numeric vector containing waypoints' index
}
\description{
find the waypoints according to certain columns of data
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vdjPseudobulk.R
\name{.featureSpaceConstruct}
\alias{.featureSpaceConstruct}
\title{Construct VDJ feature space}
\usage{
.featureSpaceConstruct(milo, extract_cols, pbs)
}
\arguments{
\item{milo}{Milo or SingleCellExperiment object provided by user}

\item{extract_cols}{columns of names where to extract the VDJ information}

\item{pbs}{cell x pseudobulk adjacent matrix}
}
\value{
constructed feature space
}
\description{
Construct VDJ feature space
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/projectProbability.R
\name{.calDif}
\alias{.calDif}
\title{function help to calculate the diffusion distance}
\usage{
.calDif(idx, eigenvector, lambda_t, K)
}
\arguments{
\item{idx}{integer the index of the calculated value}

\item{eigenvector}{numeric vector, the eigenvector from diffusion map}

\item{lambda_t}{eigenvalues to the power of t(diffusion time)}

\item{K}{The number of the eigenvectors to be used in calculation}
}
\value{
updated diffusion distance matrix after one iteration
}
\description{
function help to calculate the diffusion distance
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{demo_sce}
\alias{demo_sce}
\title{Example SCE Dataset that does not contain V(D)J information}
\format{
A \code{SingleCellExperiment} object with the following slots:
\describe{
\item{\code{colData}}{
A minimall \code{DataFrame} containing metadata about each sample,
corresponding to \code{obs} in AnnData (Python).
The following columns are relevant for vignette usage:
\describe{
\item{\code{anno_lvl_2_final_clean}}{
Cell type annotations.
}
}
}
\item{\code{int_colData}}{
A \code{DataFrame} containing additional assay metadata important for further
analysis. Includes:
\itemize{
\item{\code{X_scvi}}: A dimensionality reduction matrix from the scVI
model.
\item{\code{UMAP}}: A UMAP reduction matrix.
}
}
}
}
\source{
Suo et al., 2024, \emph{Nature Biotechnology}. \cr
\url{https://www.nature.com/articles/s41587-023-01734-7}.
}
\usage{
data(demo_sce)
}
\description{
The \code{demo_sce} object is a down-sampled demo dataset derived from
Suo et al., 2024, \emph{Nature Biotechnology}.\cr
This dataset is used in vignettes to demonstrate workflows for V(D)J
analysis.\cr For details, see the original
publication at \url{https://www.nature.com/articles/s41587-023-01734-7}.
The original Lymphoid cells data in h5ad format is available at
\url{https://developmental.cellatlas.io/fetal-immune}.
}
\examples{
data(demo_sce)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/minMaxScale.R
\name{.minMaxScale}
\alias{.minMaxScale}
\title{minMaxScale}
\usage{
.minMaxScale(data)
}
\arguments{
\item{data}{dataframe need to be scale}
}
\value{
scaled value
}
\description{
scale the value to range 0 to 1
}
\keyword{internal}
